<?php
/*
 * $Id: blocks_recent.php 320 2007-07-11 13:31:48Z hodaka $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

eval('
function b_'.strtolower($mytrustdirname).'_top_blogs_show($options)
{
    return b_weblogd3_top_blogs_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_top_blogs_show_base' )) {
// $options[0] is always weblog dirname.
/*
 * $options[1] = max results
 * $options[2] = use avatars
 * $options[3] = link to entry list
 */
function b_weblogd3_top_blogs_show_base($options) {
    global $xoopsDB, $xoopsUser;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $max_results = $options[1];
    $use_avatars = $options[2];
    $link_entries = $options[3];
    $this_template = empty( $options[4] ) ? 'db:'.$mydirname.'_block_top_blogs.html' : trim( $options[4] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

    $block = array();
    $rank = 0;

    $sql = sprintf('SELECT b.user_id, b.created, u.uname, u.user_avatar, count(b.blog_id) as count FROM %s as b, %s as u',
                   $xoopsDB->prefix($mydirname.'_entry'), $xoopsDB->prefix('users'));
	$sql = sprintf('%s WHERE (b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) AND b.user_id=u.uid GROUP BY b.user_id ORDER BY count DESC, b.created DESC',
                   $sql, $currentuid, time());
    $result = $xoopsDB->query($sql, $max_results, 0);

    while ($myrow = $xoopsDB->fetchArray($result)) {
        $rank++;

        // Get the user, and retrieve his avatar
        $entry = array();
        $entry['rank'] = $rank;

        // Retrieve his/her avatar
        $entry['use_avatar'] = 0;
        $entry['avatar_img'] = '';
        if ($use_avatars==1) {
            $avatar = $myrow['user_avatar'];
            if (!empty($avatar) && $avatar != 'blank.gif') {
                $entry['use_avatar'] = 1;
                $entry['avatar_img'] = sprintf('%s/uploads/%s', XOOPS_URL, $avatar);
            }
        }
        if ($link_entries==1) {
            $entry['profile_uri'] = sprintf('%s/modules/%s/index.php?user_id=%d',
                                            XOOPS_URL, $mydirname, $myrow['user_id']);
        } else {
            $entry['profile_uri'] = sprintf('%s/userinfo.php?uid=%d', XOOPS_URL, $myrow['user_id']);
        }
        $entry['uname'] = $myrow['uname'];
        $entry['count'] = $myrow['count'];
        $block['entries'][] = $entry;
    }
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_top_blogs_edit($options)
{
    return b_weblogd3_top_blogs_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_top_blogs_edit_base' )) {
/*
 * $options[1] = max results
 * $options[2] = use avatars
 * $options[3] = link to entry list
 */
function b_weblogd3_top_blogs_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;	

    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_ENTRIES, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_USE_AVATARS, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_LINK_TO_LIST, intval($options[3]));
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_blogs_show($options)
{
    return b_weblogd3_recent_blogs_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_blogs_show_base' )) {
/*
 * $options[1] = number of entries to show
 * $options[2] = max size of the title
 * $options[3] = date format
 * $options[4] = use avatars (only in large mode)
 * $options[5] = size (1=small, 2=midium, 3=large)
 * $options[6] = link to entry list (only when author names shown)
 * $options[7] = show entry content or not
 * $options[8] = max size of entry.(if this value is zero , not show )
 * $options[9] = original template file
 * $options[10] = dummy int for d3pipes(Do not change.)
 */
 
function b_weblogd3_recent_blogs_show_base($options) {
    global $xoopsDB, $xoopsUser, $xoopsConfig;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $max_entries = !empty($options[1])? intval($options[1]) : 5;
    $max_size = !empty($options[2])? intval($options[2]) : 25;
    $date_format = !empty($options[3])? trim($options[3]) : 'Y/m/d';
    $use_avatars = !empty($options[4])? intval($options[4]) : 0;
    $block_size = !empty($options[5])? intval($options[5]) : 1;
    $link_entries = !empty($options[6])? intval($options[6]) : 0;
    $show_contents = !empty($options[7])? intval($options[7]) : 0;
    $max_size_contents = !empty($options[8])? intval($options[8]) : 100;
    $this_template = empty( $options[9] ) ? 'db:'.$mydirname.'_block_recent_blogs.html' : trim( $options[9] );
    $return_data = !empty($options[10])? 1 : 0;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
    $user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;

	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

    // all categories
    $all_categories = array();
    $res = $xoopsDB->query('select * from '.$xoopsDB->prefix($mydirname.'_category')); 
    while($my = $xoopsDB->fetchArray($res)) {
        $all_categories[intval($my['cat_id'])] = htmlspecialchars($my['cat_title'], ENT_QUOTES);
    }
  
    $myts =& MyTextSanitizer::getInstance();
    $block = array();

    require_once dirname(dirname(__FILE__)).'/include/config.php';
    $wb_configs = get_wb_moduleconfig($mydirname) ;

    list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($wb_configs , $mydirname) ;

//    $sql = sprintf('SELECT b.blog_id, b.created+%d as created, b.user_id, b.title, %s as contents, b.comments, b.`reads`, b.trackbacks, u.uname, u.user_avatar FROM %s as b, %s as u',
    $sql = sprintf('SELECT b.cat_id, b.blog_id, b.created+%d as created, b.user_id, b.title, %s as contents, b.comments, b.`reads`, b.trackbacks, b.dohtml, b.dobr, u.uname, u.user_avatar FROM %s as b, %s as u',
                   $useroffset*3600, $bl_contents_field , $xoopsDB->prefix( $mydirname.'_entry' ) , $xoopsDB->prefix('users'));

    $sql = sprintf('%s WHERE ((b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) AND b.user_id=u.uid %s) ',
                   $sql, $currentuid , time(), $permission_group_sql );
    $sql .= ' ORDER BY b.created DESC';

    $result = $xoopsDB->query($sql, $max_entries, 0);

    $alart = false ;
    while ($myrow=$xoopsDB->fetchArray($result)) {
        $entry = array();
        $title = $myts->makeTboxData4Show($myrow['title']);
        if ( $block_size != 3) {
            if (strlen($title) >= $max_size) {
                $title = xoops_substr($title, 0, ($max_size -1)) ;
            }
        }

        if( $show_contents && $max_size_contents ){
			if( ! class_exists('WeblogEntryBase') )
				require_once dirname(dirname(__FILE__)).'/class/entry.php';

			$get_entries_mode = ( $max_size_contents <= 1 ) ? 'index' : 'details' ;
//          $contents = WeblogEntryBase::parse_viewmode( strip_tags($myts->displayTarea($myrow['contents'])) , $myrow['blog_id'] , $get_entries_mode , $mydirname) ;
            $contents = WeblogEntryBase::parse_viewmode( $myts->displayTarea($myrow['contents'], $myrow['dohtml'], 1, 1, 1, $myrow['dobr']) , $myrow['blog_id'] , $get_entries_mode , $mydirname);
            
            if($max_size_contents > 1)
                $contents = xoops_substr( $contents , 0 , $max_size_contents ) ;
        }else{
			$contents = "" ;
		}
        // Retrieve his/her avatar
        $entry['use_avatar'] = 0;
        $entry['avatar_img'] = '';
        if ($use_avatars==1) {
            $avatar = $myrow['user_avatar'];
            if (!empty($avatar) && $avatar != 'blank.gif') {
                $entry['use_avatar'] = 1;
                $entry['avatar_img'] = sprintf('%s/uploads/%s', XOOPS_URL, $avatar);
            }
        }

        $entry['uname'] = $myts->makeTboxData4Show($myrow['uname']);
        if ($link_entries==1) {
            $entry['profile_uri'] = sprintf('%s/modules/%s/index.php?user_id=%d',
                                            XOOPS_URL, $mydirname, $myrow['user_id']);
        } else {
            $entry['profile_uri'] = sprintf('%s/userinfo.php?uid=%d', XOOPS_URL, $myrow['user_id']);
        }
        $entry['title'] = $title;
        $entry['contents'] = $contents ;
        $entry['entry_url'] = sprintf('%s/modules/%s/details.php?blog_id=%d',
                                      XOOPS_URL, $mydirname, $myrow['blog_id']);
        $entry['created'] = intval($myrow['created']);
        $entry['date'] = formatTimestamp($myrow['created'], $date_format, $xoopsConfig['default_TZ']);
        $entry['comments'] = $myrow['comments'];
        $entry['trackbacks'] = $myrow['trackbacks'];
        $entry['reads'] = $myrow['reads'];
        $entry['permission'] = bl_permission_alart($myrow['contents']);
        if(in_array(intval($myrow['cat_id']), array_keys($all_categories))) {
            $entry['cat_title'] = $all_categories[intval($myrow['cat_id'])];
        } else {
            $entry['cat_title'] = '';
        }
        if( $entry['permission'] ) $alart = true ;
        $block['entries'][] = $entry;

    }

    $block['type'] = $block_size;
    $block['lang_recentblogs_summary'] = constant($constpref.'_SUMMARY_RECENT_BLOGS');
    $block['show_contents'] = ( $show_contents && $max_size_contents ) ? true : false ;
    $block['lang_title'] = constant($constpref.'_LANG_TITLE');
    $block['lang_author'] = constant($constpref.'_LANG_AUTHOR');
    $block['lang_comments'] = constant($constpref.'_LANG_COMMENTS');
    $block['lang_trackbacks'] = constant($constpref.'_LANG_TRACKBACKS');
    $block['lang_posted'] = constant($constpref.'_LANG_POSTED');
    $block['lang_reads'] = constant($constpref.'_LANG_READS');
    $block['weblogs_url'] = sprintf('%s/modules/%s/index.php', XOOPS_URL, $mydirname);
    $module_handler =& xoops_gethandler('module');
	$module =& $module_handler->getByDirname($mydirname);
    $block['lang_moreweblogs'] = sprintf(constant($constpref.'_LANG_MOREWEBLOGS'), $module->getVar('name'));
	if ($user_id > 0 ) {
	    $blogOwner = new XoopsUser($user_id);
	    $block['lang_whose'] = sprintf(constant($constpref.'_LANG_ENTRIES_FOR'), $blogOwner->getVar('uname'));
	}
	if( $alart ){
		$block['lang_denote'] = constant($constpref.'_LANG_DENOTE_PERMIT');
	}

    if($return_data) {
        return $block;
    } else {
        $tpl =& new XoopsTpl();
        $tpl->assign( 'block' , $block );
        $ret['content'] = $tpl->fetch( $this_template );
        return $ret;
    }
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_blogs_edit($options)
{
    return b_weblogd3_recent_blogs_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_blogs_edit_base' )) {
function b_weblogd3_recent_blogs_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
   	$form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_ENTRIES, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_TITLE_LENGTH, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_DATE_FORMAT, $options[3]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_USE_AVATARS, $options[4]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_TYPE, $options[5]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_LINK_TO_LIST, intval($options[6]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_SHOW_CONTENTS, intval($options[7]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_CONTENTS_LENGTH, intval($options[8]));
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_latest_content_show($options)
{
    return b_weblogd3_latest_content_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_latest_content_show_base' )) {
/**
 * added for a top page introduction block of the latest blog
 * @author hodaka@kuri3.net
 */
function b_weblogd3_latest_content_show_base($options) {
	global $xoopsDB, $xoopsUser, $xoopsConfig;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
	$max_entries = $options[1];
	$max_size = $options[2];
	$date_format = $options[3];
	$use_avatars = $options[4];
	$block_size = $options[5];
	$link_entries = $options[6];
	$show_contents = intval($options[7]);
	$max_size_contents = intval($options[8]);
    $this_template = empty( $options[9] ) ? 'db:'.$mydirname.'_block_latest_content.html' : trim( $options[9] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

	$currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
	$user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;

	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

    // all categories
    $all_categories = array();
    $res = $xoopsDB->query('select * from '.$xoopsDB->prefix($mydirname.'_category')); 
    while($my = $xoopsDB->fetchArray($res)) {
        $all_categories[intval($my['cat_id'])] = htmlspecialchars($my['cat_title'], ENT_QUOTES);
    }

	$myts =& MyTextSanitizer::getInstance();
	$block = array();

	require_once dirname(dirname(__FILE__)).'/include/config.php';
	$wb_configs = get_wb_moduleconfig($mydirname) ;

	list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($wb_configs , $mydirname) ;

//	$sql = sprintf('SELECT b.blog_id, b.created+%d as created, b.user_id, b.title, %s as contents, b.comments, b.`reads`, b.trackbacks, u.uname, u.user_avatar, b.dohtml, b.dobr FROM %s as b, %s as u',
    $sql = sprintf('SELECT b.cat_id, b.blog_id, b.created+%d as created, b.user_id, b.title, %s as contents, b.comments, b.`reads`, b.trackbacks, b.dohtml, b.dobr, u.uname, u.user_avatar FROM %s as b, %s as u',
                   $useroffset*3600, $bl_contents_field , $xoopsDB->prefix( $mydirname.'_entry' ) , $xoopsDB->prefix('users'));
	$sql = sprintf('%s WHERE ((b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) AND b.user_id=u.uid %s ) ',
                   $sql, $currentuid, time(), $permission_group_sql );
	$sql .= ' ORDER BY b.created DESC';

	$result = $xoopsDB->query($sql, $max_entries, 0);

	$alart = false ;
	while ($myrow=$xoopsDB->fetchArray($result)) {
		$entry = array();
		$title = $myts->makeTboxData4Show($myrow['title']);
		if ( $block_size != 3) {
			if (strlen($title) >= $max_size) {
				$title = xoops_substr($title, 0, ($max_size -1)) ;
			}
		}

		if( $show_contents && $max_size_contents ){
			if( ! class_exists('WeblogEntryBase') ) {
				require_once dirname(dirname(__FILE__)).'/class/entry.php';
			}

            $get_entries_mode = ( $max_size_contents <= 1 ) ? 'index' : 'details' ;
//          $contents = WeblogEntryBase::parse_viewmode( strip_tags($myts->displayTarea($myrow['contents'])) , $myrow['blog_id'] , $get_entries_mode , $mydirname) ;
            $contents = WeblogEntryBase::parse_viewmode( $myts->displayTarea($myrow['contents'], $myrow['dohtml'], 1, 1, 1, $myrow['dobr']) , $myrow['blog_id'] , $get_entries_mode , $mydirname);

			if($max_size_contents > 1) {
				$contents = xoops_substr( $contents , 0 , $max_size_contents ) ;
			}
		}else{
			$contents = "" ;
		}
		// Retrieve his/her avatar
		$entry['use_avatar'] = 0;
		$entry['avatar_img'] = '';
		if ($use_avatars==1) {
			$avatar = $myrow['user_avatar'];
			if (!empty($avatar) && $avatar != 'blank.gif') {
				$entry['use_avatar'] = 1;
				$entry['avatar_img'] = sprintf('%s/uploads/%s', XOOPS_URL, $avatar);
			}
		}

		$entry['uname'] = $myts->makeTboxData4Show($myrow['uname']);
		if ($link_entries==1) {
			$entry['profile_uri'] = sprintf('%s/modules/%s/index.php?user_id=%d',
                                    XOOPS_URL, $mydirname, $myrow['user_id']);
		} else {
			$entry['profile_uri'] = sprintf('%s/userinfo.php?uid=%d', XOOPS_URL, $myrow['user_id']);
		}
		$entry['title'] = $title;
		$entry['contents'] = $contents ;
		$entry['entry_url'] = sprintf('%s/modules/%s/details.php?blog_id=%d',
                                XOOPS_URL, $mydirname, $myrow['blog_id']);
		$entry['date'] = formatTimestamp($myrow['created'], $date_format, $xoopsConfig['default_TZ']);
		$entry['comments'] = $myrow['comments'];
		$entry['trackbacks'] = $myrow['trackbacks'];
		$entry['reads'] = $myrow['reads'];
		$entry['permission'] = bl_permission_alart($myrow['contents']);
        if(in_array(intval($myrow['cat_id']), array_keys($all_categories))) {
            $entry['cat_title'] = $all_categories[intval($myrow['cat_id'])];
        } else {
            $entry['cat_title'] = '';
        }
		if( $entry['permission'] ) $alart = true ;
		$block['entries'][] = $entry;
	}

	$block['type'] = $block_size;
    $block['lang_latestcontents_summary'] = constant($constpref.'_SUMMARY_LATEST_CONTENTS');
	$block['show_contents'] = ( $show_contents && $max_size_contents ) ? true : false ;
	$block['lang_title'] = constant($constpref.'_LANG_TITLE');
	$block['lang_author'] = constant($constpref.'_LANG_AUTHOR');
    $block['lang_comments'] = constant($constpref.'_LANG_COMMENTS');
    $block['lang_trackbacks'] = constant($constpref.'_LANG_TRACKBACKS');
	$block['lang_posted'] = constant($constpref.'_LANG_POSTED');
	$block['lang_reads'] = constant($constpref.'_LANG_READS');
	$block['weblogs_url'] = sprintf('%s/modules/%s/index.php', XOOPS_URL, $mydirname);
    $module_handler =& xoops_gethandler('module');
    $module =& $module_handler->getByDirname($mydirname);
	$block['lang_moreweblogs'] = sprintf(constant($constpref.'_LANG_MOREWEBLOGS'), $module->getVar('name'));
	if ($user_id > 0 ) {
		$blogOwner = new XoopsUser($user_id);
		$block['lang_whose'] = sprintf(constant($constpref.'_ENTRIES_FOR'), $blogOwner->getVar('uname','E'));
	}
	if( $alart ){
		$block['lang_denote'] = constant($constpref.'_LANG_DENOTE_PERMIT');
	}

    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_latest_content_edit($options)
{
    return b_weblogd3_latest_content_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_latest_content_edit_base' )) {
function b_weblogd3_latest_content_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_ENTRIES, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_TITLE_LENGTH, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_DATE_FORMAT, $options[3]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_USE_AVATARS, $options[4]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_TYPE, $options[5]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_LINK_TO_LIST, intval($options[6]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_SHOW_CONTENTS, intval($options[7]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_CONTENTS_LENGTH, intval($options[8]));
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_users_blogs_show($options)
{
    return b_weblogd3_users_blogs_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_users_blogs_show_base' )) {
/*
 * $options[1] = number of users to show
 * $options[2] = number of entries to show
 * $options[3] = date format
 * $options[4] = use avatars (only in large mode)
 * $options[5] = size (1=small, 2=midium, 3=large)
 * $options[6] = what order by (Last entry time or Total Reads)
 * $options[7] = max size of the title
 * $options[8] = show entry content or not
 * $options[9] = max size of entry.(if this value is zero , not show )
 */
function b_weblogd3_users_blogs_show_base($options) {

    global $xoopsDB, $xoopsUser, $xoopsConfig ;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $max_users = $options[1];
    $max_entries = $options[2];
    $date_format = $options[3];
    $use_avatars = $options[4];
    $block_size = $options[5];
    $order_by = $options[6];
    $max_size = $options[7];
	$show_contents = intval($options[8]);
	$max_size_contents = intval($options[9]);
    $this_template = empty( $options[10] ) ? 'db:'.$mydirname.'_block_users_blogs.html' : trim( $options[10] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
  
    $myts =& MyTextSanitizer::getInstance();
    $block = array();

	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

	if( $order_by == 0 ){	 // last entry time
	    $user_sql = sprintf('select user_id,uname,user_avatar,max(created)+%d as sort_value from %s b , %s u where b.user_id=u.uid ', 
					$useroffset*3600, $xoopsDB->prefix( $mydirname.'_entry' ) , $xoopsDB->prefix('users') );
		$sort_value = constant($constpref.'_USERS_SORT_UPDATE');
	}else{		// order by most reads user
	    $user_sql = sprintf('select user_id,uname,user_avatar,sum(`reads`) as sort_value from %s b , %s u where b.user_id=u.uid ', 
					$xoopsDB->prefix( $mydirname.'_entry' ) , $xoopsDB->prefix('users') );
		$sort_value = constant($constpref.'_USERS_SORT_READS');
	}
	$user_sql .= ' group by user_id order by sort_value desc ' ;

    $result_user = $xoopsDB->query($user_sql, $max_users, 0);
    require_once dirname(dirname(__FILE__)).'/include/config.php';
	$wb_configs = get_wb_moduleconfig($mydirname) ;
    list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($wb_configs , $mydirname) ;

	$users = array() ;
	$alart = false ;
    while ($userrow=$xoopsDB->fetchArray($result_user)) {
		$user_id = $myts->makeTboxData4Show($userrow['user_id']) ;
		$user_sortvalue = ( $order_by == 0 ) ? date(  $date_format , $myts->makeTboxData4Show($userrow['sort_value'])  ) : $myts->makeTboxData4Show($userrow['sort_value']) ;
		$users[$user_id] = array(
				'uname' => $myts->makeTboxData4Show($userrow['uname']) ,
				'avatar_img' => sprintf( '%s/uploads/%s', XOOPS_URL, $myts->makeTboxData4Show($userrow['user_avatar']) ) ,
				'sort_value' => $user_sortvalue ,
				'profile_uri' => sprintf('%s/userinfo.php?uid=%d', XOOPS_URL, $user_id) ,
				'user_blog_uri' => sprintf('%s/modules/%s/index.php?user_id=%d', XOOPS_URL, $mydirname , $user_id) ,
				'entries' => array() ) ;
		// get user's entries 
		$entry_sql = sprintf('select blog_id,user_id,created+%d as created,title,%s as contents,`reads`,comments,trackbacks from %s b where (user_id=\'%d\') AND (user_id=\'%d\' OR (private = \'N\' AND created<=\'%d\'))  %s order by created desc ',
								 $useroffset*3600, $bl_contents_field , $xoopsDB->prefix( $mydirname.'_entry' ) , $user_id, $currentuid , time(), $permission_group_sql);

		$result_entry = $xoopsDB->query($entry_sql , $max_entries , 0) ;
		$users[$user_id]['entry_num_plus1'] = $xoopsDB->getRowsNum($result_entry) +1  ;	// used by template rowspan
		while( $entryrow = $xoopsDB->fetchArray($result_entry) ){
	        $entry_url = sprintf('%s/modules/%s/details.php?blog_id=%d', XOOPS_URL, $mydirname, $entryrow['blog_id']);
            if( $show_contents && $max_size_contents ){
				if( ! class_exists('WeblogEntryBase') )
					require_once dirname(dirname(__FILE__)).'/class/entry.php';
				$get_entries_mode = ( $max_size_contents < 0 ) ? 'index' : 'rss' ;
				$contents = WeblogEntryBase::parse_viewmode( strip_tags($myts->displayTarea($entryrow['contents'])) , $entryrow['blog_id'] ,$get_entries_mode , $mydirname) ;
				if($max_size_contents > 0)
					$contents = xoops_substr( $contents , 0 , $max_size_contents ) ;
			}else{
				$contents = "" ;
			}
			$users[$user_id]['entries'][] = array(
				'created' => date( $date_format , $myts->makeTboxData4Show($entryrow['created']) ) ,
				'title' => xoops_substr($myts->makeTboxData4Show($entryrow['title']) , 0 , $max_size),
				'contents' => $contents ,
				'entry_url' => $entry_url ,
				'reads' => $myts->makeTboxData4Show($entryrow['reads']) ,
				'comments' => $myts->makeTboxData4Show($entryrow['comments']) ,
				'trackbacks' => $myts->makeTboxData4Show($entryrow['trackbacks']) ,
				'permission' => bl_permission_alart($entryrow['contents']) 
			) ;
			if( bl_permission_alart($entryrow['contents']) ) $alart = true ;
		}
	}

	$block['users'] =& $users ;
    $block['type'] = $block_size;
    $block['show_contents'] = ( $show_contents && $max_size_contents ) ? true : false ;
    $block['use_avatars'] = $use_avatars ;
    $block['lang_usersblog_summary'] = constant($constpref.'_SUMMARY_USERS_BLOG');
    $block['lang_user_sort_value'] = $sort_value;
    $block['lang_title'] = constant($constpref.'_LANG_TITLE');
    $block['lang_entries'] = constant($constpref.'_LANG_ENTRIES');
    $block['lang_author'] = constant($constpref.'_LANG_AUTHOR');
    $block['lang_comments'] = constant($constpref.'_LANG_COMMENTS');
    $block['lang_trackbacks'] = constant($constpref.'_LANG_TRACKBACKS');
    $block['lang_posted'] = constant($constpref.'_LANG_POSTED');
    $block['lang_reads'] = constant($constpref.'_LANG_READS');
    $module_handler =& xoops_gethandler('module');
	$module =& $module_handler->getByDirname($mydirname);
    $block['lang_moreweblogs'] = sprintf(constant($constpref.'_LANG_MOREWEBLOGS'), $module->getVar('name'));
    $block['weblogs_url'] = sprintf('%s/modules/%s/index.php', XOOPS_URL, $mydirname);
	if( $alart ){
		$block['lang_denote'] = constant($constpref.'_LANG_DENOTE_PERMIT');
	}
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_users_blogs_edit($options)
{
    return b_weblogd3_users_blogs_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_users_blogs_edit_base' )) {
function b_weblogd3_users_blogs_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_USERS, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_ENTRIES, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_DATE_FORMAT, $options[3]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_USE_AVATARS, $options[4]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_TYPE, $options[5]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_ORDER_BY, intval($options[6]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_TITLE_LENGTH, intval($options[7]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_SHOW_CONTENTS, intval($options[8]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_CONTENTS_LENGTH, intval($options[9]));
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_tb_show($options)
{
    return b_weblogd3_recent_tb_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_tb_show_base' )) {
function b_weblogd3_recent_tb_show_base($options) {
    global $xoopsDB, $xoopsUser, $xoopsConfig ;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $max_trackbacks = $options[1];
    $max_size = $options[2];
    $date_format = $options[3];
    $block_size = $options[4];
    $this_template = empty( $options[5] ) ? 'db:'.$mydirname.'_block_recent_tb.html' : trim( $options[5] ) ;
    
	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
    $user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;
  
	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

    require_once dirname(dirname(__FILE__)).'/include/config.php';
    $wb_configs = get_wb_moduleconfig($mydirname) ;
    list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($wb_configs , $mydirname) ;

    $myts =& MyTextSanitizer::getInstance();
    $block = array();
	$block['trackbacks'] = array() ;
    $sql = sprintf('SELECT b.user_id, t.blog_id, if(t.tb_url!=\'\',t.tb_url,t.link) as link , t.blog_name, t.title as tb_title, t.trackback_created+%d as trackback_created ,b.title as entry_title,%s as contents FROM %s as t , %s as b',
                   $useroffset*3600, $bl_contents_field , $xoopsDB->prefix($mydirname.'_trackback') ,$xoopsDB->prefix($mydirname.'_entry') );
//    $sql = sprintf('%s WHERE t.blog_id=b.blog_id and (b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) and t.direction=\'received\' %s ',
    $sql = sprintf('%s WHERE t.blog_id=b.blog_id and (b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) and t.direction=\'received\' and t.tbkey<>t.tb_url %s ',
                   $sql, $currentuid, time(), $permission_group_sql );

    $sql .= ' ORDER BY t.trackback_created DESC';

    $result = $xoopsDB->query($sql, $max_trackbacks, 0);
	$alart = false ;
    while ($myrow=$xoopsDB->fetchArray($result)) {
        $trackback = array();
        $tb_title = $myts->makeTboxData4Show($myrow['tb_title']);
        if ( $block_size != 3) {
            if (strlen($tb_title) >= $max_size) {
                $tb_title = xoops_substr($tb_title, 0, ($max_size -1)) ;
            }
        }

        $trackback['blog_name'] = $myts->makeTboxData4Show($myrow['blog_name']);
        $trackback['link'] = $myts->makeTboxData4Show($myrow['link']);
        $trackback['tb_title'] = $tb_title;
        $trackback['entry_url'] = sprintf('%s/modules/%s/details.php?blog_id=%d',
                                      XOOPS_URL, $mydirname, $myrow['blog_id']);
        $trackback['date'] = formatTimestamp($myrow['trackback_created'], $date_format, $xoopsConfig['default_TZ']);
        $trackback['entry_title'] = $myts->makeTboxData4Show($myrow['entry_title']);
        $trackback['permission'] = bl_permission_alart($myrow['contents']) ;
        if( $trackback['permission'] ) $alart = true ;
        $block['trackbacks'][] = $trackback;
    }

    $block['type'] = $block_size;
    $block['lang_recenttrackbacks_summary'] = constant($constpref.'_SUMMARY_RECENT_TRACKBACKS');
    $block['lang_tbtitle'] = constant($constpref.'_LANG_TB_TITLE');
    $block['lang_entrytitle'] = constant($constpref.'_LANG_TB_WEBLOGTITLE');
    $block['lang_blogname'] = constant($constpref.'_LANG_TB_BLOGNAME');
    $block['lang_posted'] = constant($constpref.'_LANG_TB_POSTED');
	if ($user_id > 0 ) {
	    $blogOwner = new XoopsUser($user_id);
	    $block['lang_whose'] = sprintf(constant($constpref.'_LANG_TRACKBACKS_FOR'), $blogOwner->getVar('uname','E'));
	}
	if( $alart ){
		$block['lang_denote'] = constant($constpref.'_LANG_DENOTE_PERMIT');
	}
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_tb_edit($options)
{
    return b_weblogd3_recent_tb_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_tb_edit_base' )) {
function b_weblogd3_recent_tb_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_TRACKBACKS, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_TITLE_LENGTH, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_DATE_FORMAT, $options[3]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_TYPE, $options[4]);
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_comment_show($options)
{
    return b_weblogd3_recent_comment_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_comment_show_base' )) {
function b_weblogd3_recent_comment_show_base($options) {
    global $xoopsDB, $xoopsUser, $xoopsConfig ;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $max_comments = $options[1];
    $max_size = $options[2];
    $date_format = $options[3];
    $block_size = $options[4];
    $this_template = empty( $options[5] ) ? 'db:'.$mydirname.'_block_recent_comment.html' : trim( $options[5] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
    $user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;
  
	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

    require_once dirname(dirname(__FILE__)).'/include/config.php';
    $wb_configs = get_wb_moduleconfig($mydirname) ;
    list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($wb_configs , $mydirname) ;

    $myts =& MyTextSanitizer::getInstance();
    $block = array();
	$block['comments'] = array() ;
    $sql = sprintf('SELECT com_id, com_modified+%d as com_modified, com_uid, com_title, com_itemid, title,%s as contents, uname FROM %s as xc , %s as m , %s as b , %s as u' , 
                    $useroffset*3600, $bl_contents_field , $xoopsDB->prefix('xoopscomments') , $xoopsDB->prefix('modules') ,$xoopsDB->prefix($mydirname.'_entry') ,$xoopsDB->prefix('users') );
    $sql = sprintf('%s WHERE com_modid=mid and dirname=\'%s\' and (b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) and blog_id=com_itemid and com_status=2 and (com_uid=uid or com_uid=0)',
                   $sql, $mydirname ,$currentuid, time() );
    if(!empty($user_id))
        $sql .= " and b.user_id='".$user_id."'";
    $sql .= ' '.$permission_group_sql.' group by com_id ORDER BY com_modified DESC';
    $result = $xoopsDB->query($sql, $max_comments, 0);
	$alart = false ;
    while ($myrow=$xoopsDB->fetchArray($result)) {
        $comment = array();
        $com_title = $myts->makeTboxData4Show($myrow['com_title']);
        if ( $block_size != 3) {
            if (strlen($com_title) >= $max_size) {
                $com_title = xoops_substr($com_title, 0, ($max_size -1)) ;
            }
        }

        $comment['com_title'] = $com_title;
        $comment['date'] = formatTimestamp($myrow['com_modified'], $date_format, $xoopsConfig['default_TZ']);
        $comment['entry_url'] = sprintf('%s/modules/%s/details.php?blog_id=%d#comment%d',
                                      XOOPS_URL, $mydirname, intval($myrow['com_itemid']), intval($myrow['com_id']));
        $comment['entry_title'] = $myts->makeTboxData4Show($myrow['title']);
        $comment['permission'] = bl_permission_alart($myrow['contents']) ;
		if( $comment['permission'] ) $alart = true ; 
		$comment['com_uname'] = ( $myrow['com_uid'] == 0 ) ? $xoopsConfig['anonymous'] : $myts->makeTboxData4Show($myrow['uname']);
		if( $myrow['com_uid'] != 0 )
			$comment['profile_uri'] = sprintf('%s/userinfo.php?uid=%d', XOOPS_URL, intval($myrow['com_uid']) );
        $block['comments'][] = $comment ;
    }

    $block['type'] = $block_size;
    $block['lang_comuname'] = constant($constpref.'_LANG_COM_UNAME');
    $block['lang_comtitle'] = constant($constpref.'_LANG_COM_TITLE');
    $block['lang_entrytitle'] = constant($constpref.'_LANG_COM_WEBLOGTITLE');
    $block['lang_posted'] = constant($constpref.'_LANG_COM_POSTED');
    $block['lang_comments_summary'] = constant($constpref.'_SUMMARY_COMMENTS_LIST');
	if ($user_id > 0 ) {
	    $blogOwner = new XoopsUser($user_id);
	    $block['lang_whose'] = sprintf(constant($constpref.'_LANG_COMMENTS_FOR'), $blogOwner->getVar('uname','E'));
	}
	if( $alart ){
		$block['lang_denote'] = constant($constpref.'_LANG_DENOTE_PERMIT');
	}
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_comment_edit($options)
{
    return b_weblogd3_recent_comment_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_comment_edit_base' )) {
function b_weblogd3_recent_comment_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_COMMENTS, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_TITLE_LENGTH, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_DATE_FORMAT, $options[3]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_TYPE, $options[4]);
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_image_show($options)
{
    return b_weblogd3_recent_image_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_image_show_base' )) {
function b_weblogd3_recent_image_show_base($options) {
    global $xoopsDB, $xoopsUser, $xoopsConfig ;

	if( function_exists("gd_info") ){
		$gd_infomation = gd_info() ;
		if( substr( $gd_infomation['GD Version'] , 0 , 10 ) != 'bundled (2' )	// GD version 2 is required
			return false ;
	}

	$mydirname = empty( $options[0] ) ? 'weblogD3': $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $max_images = $options[1];
    $max_title_length = $options[2];
    $max_contents_length = $options[3];
    $date_format = $options[4];
    $show_forbidden_pic = $options[5];
    $this_template = empty( $options[6] ) ? 'db:'.$mydirname.'_block_recent_image.html' : trim( $options[6] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    $block = array();
	$block['images'] = array() ;
	
    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
    $user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;
 
	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

    require_once dirname(dirname(__FILE__)).'/include/config.php';
    $wb_configs = get_wb_moduleconfig($mydirname) ;
    list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($wb_configs , $mydirname) ;

    $myts =& MyTextSanitizer::getInstance();

	$weblog_image_url = XOOPS_URL . $wb_configs['weblog_myalbum_photospath'] ;
    $sql = sprintf('SELECT blog_id, user_id , uname, created+%d as created, title, contents , %s as contents_p FROM %s as b , %s as u' , 
                   $useroffset*3600, $bl_contents_field , $xoopsDB->prefix($mydirname.'_entry') , $xoopsDB->prefix('users') );
    $sql = sprintf('%s WHERE b.user_id=u.uid and (b.user_id=\'%d\' OR (b.private = \'N\' AND b.created<=\'%d\')) and b.contents like \'%s\' %s ',
                   $sql , $currentuid , time(), '%'.$weblog_image_url.'%' , $permission_group_sql );
    $sql .= ' ORDER BY created DESC';

    $result = $xoopsDB->query($sql, $max_images, 0);
	$alart = false ;
    while ($myrow=$xoopsDB->fetchArray($result)) {
        $image = array();
		$title = "" ;
		if( $max_title_length > 0 ){
	        $title = $myts->makeTboxData4Show($myrow['title']);
	       	if (strlen($title) >= $max_title_length)
	                $title = xoops_substr($title, 0, ($max_title_length -1)) ;
		}
		$contents = "" ;
		if( $max_contents_length > 0 ){
	        $contents = strip_tags( $myts->xoopsCodeDecode($myrow['contents']) );
	       	if (strlen($contents) >= $max_contents_length)
                $contents = xoops_substr($contents, 0, ($max_contents_length -1)) ;
		}

		$image['permission'] = bl_permission_alart($myrow['contents_p']) ;
		if( $image['permission'] ) $alart = true ;

		$img_pattern = "/\[img( align=['\"]?)?(left|center|right)?]([^\"\(\)\?\&'<>]*)\[\/img\]/sU";
		$image['image_url'] = array() ;
		if( ! (! $show_forbidden_pic && $image['permission']) ){
	        if( preg_match_all( $img_pattern  , $myrow['contents'] , $matches) ){
				$image['image_uri'] = str_replace( $wb_configs['weblog_myalbum_photospath'] , $wb_configs['weblog_myalbum_thumbspath'] , $matches[3] );		
			}
		}
        $image['title'] = $title ;
        $image['contents'] = $contents ;
		$image['uname'] = $myrow['uname'] ;
        $image['date'] = formatTimestamp($myrow['created'], $date_format, $xoopsConfig['default_TZ']);
        $image['entry_url'] = sprintf('%s/modules/%s/details.php?blog_id=%d',
                                      XOOPS_URL, $mydirname, $myts->makeTboxData4Show($myrow['blog_id']) );
		$image['blog_uri'] = sprintf('%s/modules/%s/index.php?user_id=%d', 
                                      XOOPS_URL, $mydirname , $myts->makeTboxData4Show($myrow['user_id']) ) ;
        $block['images'][] = $image ;
    }
	if ($user_id > 0 ) {
	    $blogOwner = new XoopsUser($user_id);
	    $block['lang_whose'] = sprintf(constant($constpref.'_ENTRY_FOR'), $blogOwner->getVar('uname','E'));
	}
	if( $alart ){
		$block['lang_denote'] = constant($constpref.'_LANG_DENOTE_PERMIT');
	}
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_recent_image_edit($options)
{
    return b_weblogd3_recent_image_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_recent_image_edit_base' )) {
function b_weblogd3_recent_image_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_NUMBER_OF_ENTRIES, intval($options[1]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_TITLE_LENGTH, intval($options[2]));
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_MAX_CONTENTS_LENGTH, $options[3]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_DATE_FORMAT, $options[4]);
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%s" /></td></tr>',
                     _MB_WEBLOG_EDIT_SHOW_FORBIDDEN_PICTURE, $options[5]);
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_category_list_show($options)
{
    return b_weblogd3_category_list_show_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_category_list_show_base' )) {
/**
 *@remarks show category list with counts by hodaka
 **/
function b_weblogd3_category_list_show_base($options) {
    global $xoopsDB, $xoopsUser, $xoopsConfig ;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $this_template = empty( $options[2] ) ? 'db:'.$mydirname.'_block_category_list.html' : trim( $options[1] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;

    require_once dirname(dirname(__FILE__)).'/include/config.php';
	$sort_order = ($options[1] == 1)? "cat_id" : "cat_title";

    $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
    $user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;
    
	include_once(sprintf('%s/class/xoopstree.php', XOOPS_ROOT_PATH));
    $cattree =& new XoopsTree($xoopsDB->prefix($mydirname . '_category'), 'cat_id', 'cat_pid');
    $array = $cattree->getChildTreeArray(0, $sort_order);

    $myts =& MyTextSanitizer::getInstance();
    $block = array();
/* simple category trees with counts alltogether with child categories, hodaka prefers */
	foreach ( $array as $cat ) {
		$cid_array = $cattree->getAllChildId($cat['cat_id']);
		array_push($cid_array, $cat['cat_id']);
		$category = array();
		$category['level'] = strval(strlen($cat['prefix']));
		$category['prefix'] = substr(str_replace(".","--",$cat['prefix']), 2);
		$category['class'] = 'weblogBlockCatLevel'.strlen($category['prefix']);
		$category['cat_id'] = $cat['cat_id'];
		$category['cat_title'] = htmlspecialchars($cat['cat_title'], ENT_QUOTES);
		$sql = "select count(blog_id) from ".$xoopsDB->prefix($mydirname.'_entry');
		$sql .= " where (user_id=$currentuid or (private='N' and created < ".time()."))";
		$sql .= " and cat_id IN (".implode(',', $cid_array).")";
		$result = $xoopsDB->query($sql);
		if($result) {
			list($category['count']) = $xoopsDB->fetchRow($result);
		} else {
			$category['count'] = 0;
		}		

		$block['categories'][] = $category;
	}

	$block['module_dirname'] = $mydirname;
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_category_list_edit($options)
{
    return b_weblogd3_category_list_edit_base($options) ;
}
');
if( ! function_exists( 'd_weblogd3_category_list_edit_base' )) {
function b_weblogd3_category_list_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
	$sel1 = ($options[1] == 1)? " selected='selected'" : "";
	$sel2 = ($options[1] == 2)? " selected='selected'" : "";
    $select_box = "<select name='options[]'>";
	$select_box .= "<option value='1'$sel1>"._MB_WEBLOG_EDIT_CAT_ID."</option>";
	$select_box .= "<option value='2'$sel2>"._MB_WEBLOG_EDIT_CAT_TITLE."</option>";
	$select_box .= "</select>";
    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td>%s</td></tr>',
                     _MB_WEBLOG_EDIT_CAT_ORDERBY, $select_box);
    $form .= '</table>';
    return $form;
}
}

/*************************
 *  functions for blocks
 *  @private
 *************************/
// alart string
function bl_permission_alart( $contents ){

	$alart = "<span style='color:#FF0000;font-size:10px'>*</span>" ;
	if( preg_match("/^GROUP_PERMIT$/i",$contents) ){
		return $alart ;
	}else{
		return "" ;
	}
}

// get weblog module configs
function get_wb_moduleconfig($mydirname){
	global $xoopsDB ;

	$config = array() ;
	$sql = sprintf('select conf_name,conf_value from %s,%s where mid=conf_modid and dirname=\'%s\' ' ,
					$xoopsDB->prefix('config') , $xoopsDB->prefix('modules') , $mydirname ) ;
	$result = $xoopsDB->query($sql);
	while( $rows = $xoopsDB->fetchArray($result) ){
		$config[$rows['conf_name']] = $rows['conf_value'] ;
	}
	return $config ;
}

?>