<?php
// $Id$

// 2005-10-01 K.OHWADA
// category, counter

// 2005-06-06 K.OHWADA
// small change for plugin.

//================================================================
// get aritciles from module
// weblog 1.42 <http://tohokuaiki.jp/>
// 2005.05.16 Hodaka <http://www.kuri3.net/>
//================================================================

eval( '
    function '.$mydirname.'_new($limit=0, $offset=0) {
        return weblogD3_new_base( "'.$mydirname.'", $limit , $offset ) ;
    }
' ) ;

if( ! function_exists( 'weblogD3_new_base' ) ) {

    function weblogD3_new_base( $mydirname, $limit=0, $offset=0 )
    {

        global $xoopsUser, $xoopsDB, $xoopsConfig;

        $myts =& MyTextSanitizer::getInstance();

        $url_mod = XOOPS_URL."/modules/".$mydirname;

        $currentuid = is_object($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

        $sql = sprintf('SELECT b.blog_id, b.created, b.title, b.contents, b.dohtml, b.dobr, b.user_id, b.reads, b.cat_id, c.cat_title FROM %s as b, %s as u',
        				$xoopsDB->prefix($mydirname.'_entry'), $xoopsDB->prefix('users'));
        $sql = sprintf('%s LEFT JOIN %s c ON b.cat_id=c.cat_id', $sql, $xoopsDB->prefix($mydirname.'_category'));
//      $sql = sprintf('%s WHERE (b.private = \'N\' OR b.user_id=\'%d\') AND b.user_id=u.uid ORDER BY b.created DESC', $sql, $currentuid);
        $sql = sprintf('%s WHERE ((b.user_id=\'%d\') OR (b.private = \'N\' AND b.created <= \'%d\')) AND b.user_id=u.uid ORDER BY b.created DESC', $sql, $currentuid, time());
        $result = $xoopsDB->query($sql, $limit, $offset);
        $i = 0;
        $ret = array();

        while ( $row=$xoopsDB->fetchArray($result) )
        {
            $ret[$i]['link']     = $url_mod."/details.php?blog_id=".intval($row['blog_id']);
            $ret[$i]['cat_link'] = $url_mod."/index.php?cat_id=".intval($row['cat_id']);
            $ret[$i]['title']    = $myts->htmlSpecialChars($row['title']);
            $ret[$i]['cat_name'] = $myts->htmlSpecialChars($row['cat_title']);
            $ret[$i]['time'] = intval($row['created']);
            $ret[$i]['uid']  = intval($row['user_id']);
            $ret[$i]['hits'] = intval($row['reads']);

            $html   = 0;
            $smiley = 1;
            $xcodes = 1;
            $image  = 1;
            $br     = 0;

            if ( $row['dohtml'] )   $html   = 1;
            if ( $row['dobr'] )     $br     = 1;

            $desc = $myts->displayTarea($row['contents'], $html, $smiley, $xcodes, $image, $br);
            $ret[$i]['description'] = $desc;

            $i++;
        }

        return $ret;
    }
}

eval( '
    function '.$mydirname.'_num() {
        return weblogD3_num_base( "'.$mydirname.'" ) ;
    }
' ) ;

if( ! function_exists( 'weblogD3_num_base' ) ) {
    function weblogD3_num_base( $mydirname ) {

        global $xoopsDB;

        $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;
        $sql = sprintf('SELECT count(b.blog_id) FROM %s as b, %s as u',
        			$xoopsDB->prefix($mydirname.'_entry'), $xoopsDB->prefix('users'));
        $sql = sprintf('%s WHERE (b.private = \'N\' OR b.user_id=\'%d\') AND b.user_id=u.uid', $sql, $currentuid);

        $sql = 'SELECT count(*) FROM '.$xoopsDB->prefix($mydirname.'_entry');
        $array = $xoopsDB->fetchRow( $xoopsDB->query($sql) );
        $num = $array[0];
        if (empty($num)) $num = 0;
        return $num;
    }
}

eval( '
function '.$mydirname.'_data( $limit=0, $offset=0 )
{
    return weblogD3_data_base( "'.$mydirname.'", $limit=0, $offset=0 ) ;
}
' ) ;

if( ! function_exists( 'weblogD3_data_base' ) ) {

    function weblogD3_data_base($mydirname, $limit=0, $offset=0)
    {
        global $xoopsDB;
        $myts =& MyTextSanitizer::getInstance();
        $currentuid = !empty($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

        $sql = sprintf('SELECT b.blog_id, b.created, b.title, c.cat_title FROM %s as b, %s as u',
        				$xoopsDB->prefix($mydirname.'_entry'), $xoopsDB->prefix('users'));
        $sql = sprintf('%s LEFT JOIN %s c ON b.cat_id=c.cat_id', $sql, $xoopsDB->prefix($mydirname.'_category'));
//        $sql = sprintf('%s WHERE (b.private = \'N\' OR b.user_id=\'%d\') AND b.user_id=u.uid ORDER BY b.created DESC', $sql, $currentuid);
        $sql = sprintf('%s WHERE (b.private = \'N\' AND b.created <= %u) OR b.user_id=%u) AND b.user_id=u.uid ORDER BY b.created DESC', $sql, time(), $currentuid);
        $result = $xoopsDB->query($sql,$limit,$offset);

        $i = 0;
        $ret = array();

        while($row = $xoopsDB->fetchArray($result))
        {
            $ret[$i]['category'] = $myts->htmlSpecialChars($row['cat_title']);
            $ret[$i]['id'] = intval($row['blog_id']);
            $ret[$i]['link'] = XOOPS_URL."/modules/".$mydirname."/details.php?blog_id=".intval($row['blog_id']);
            $ret[$i]['title'] = $myts->htmlSpecialChars($row['title']);
            $ret[$i]['time']  = intval($row['created']);
            $i++;
        }
        return $ret;
    }
}

?>