<?php
/**
 * $Id: main.php 204 2007-10-30 17:53:46Z hodaka $
 * Copyright (c) 2003 by Jeremy N. Cowgar <jc@cowgar.com>
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.zive.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

// Basic's
define('_MD_WEBLOG_DISABLEHTML', _DISABLEHTML);
define('_MD_WEBLOG_WRAPLINES', '改行を自動的に改行タグにする');
define('_MD_WEBLOG_TITLE', 'タイトル');
define('_MD_WEBLOG_DESCRIPTION', '記事本文');
define('_MD_WEBLOG_CATEGORY', 'カテゴリ');
define('_MD_WEBLOG_CATEGORIES', 'カテゴリ');
define('_MD_WEBLOG_MAIN', 'カテゴリートップ');
define('_MD_WEBLOG_CONTENTS','エントリ');
define('_MD_WEBLOG_POST','ブログ投稿');
define('_MD_WEBLOG_PREVIEW',_PREVIEW);
define('_MD_WEBLOG_PRIVATE','プライベート');
define('_MD_WEBLOG_OPTIONS','オプション');
define('_MD_WEBLOG_COMMENTS','コメント');
define('_MD_WEBLOG_READ_USERS_BLOG','%sさんのブログを読む');
define('_MD_WEBLOG_EDIT',_EDIT);
define('_MD_WEBLOG_READ','読む');
define('_MD_WEBLOG_SHOW','表示');
define('_MD_WEBLOG_DELETE',_DELETE);
define('_MD_WEBLOG_BLOG','ブログ');
define('_MD_WEBLOG_BLOGGER','ユーザー');
define('_MD_WEBLOG_GATHERING','あなたのブログエントリを集めています');
define('_MD_WEBLOG_GATHERING_SORRY','申し訳ありません、マイブログは登録ユーザのみ使用することができます');
define('_MD_WEBLOG_PRIVATE_NOTEXIST_SORRY', '申し訳ありません、このエントリはプライベートまたは存在しません。');
define('_MD_WEBLOG_ENTRY_POSTED','ブログエントリが投稿されました');
define('_MD_WEBLOG_MOST_RECENT','最新エントリ');
define('_MD_WEBLOG_ENTRIES_FOR','%sさんのエントリ');
define('_MD_WEBLOG_ENTRIES_FOR_DATE','%sのエントリ');
define('_MD_WEBLOG_ENTRIES_FOR_CATEGORY','%sのエントリ');
define('_MD_WEBLOG_ENTRY_FOR','%sさんのエントリ');
define('_MD_WEBLOG_NUMBER_OF_READS','閲覧数');
define('_MD_WEBLOG_NUMBER_OF_TRACKBACKS','トラックバック数');
define('_MD_WEBLOG_CONFIRM_DELETE','ブログエントリ(%s)を削除してもいいですか？');
define('_MD_WEBLOG_BLOG_DELETED','選択されたブログエントリは削除されました');
define('_MD_WEBLOG_BLOG_NOT_DELETED','選択されたブログエントリは削除されませんでした。アクセス権限を確認してください');
define('_MD_WEBLOG_WHOS_BLOG','%sさんのブログ');
define('_MD_WEBLOG_ANON_CANNOT_POST_SORRY','申し訳ありません。投稿権限のあるユーザのみ投稿することができます。<br />投稿を希望する場合はサイト管理者に問い合わせてください');
define('_MD_WEBLOG_CANNOT_READ_SORRY','申し訳ありませんが、閲覧権限が与えられていないので、読むことができません。<br />閲覧を希望する場合は、登録するかサイト管理者に問い合わせてください。');
define('_MD_WEBLOG_CANNOT_EDIT','投稿されたエントリは投稿者か管理者でないと編集できません。');
define('_MD_WEBLOG_DELETE_BUTTON',_DELETE);
define('_MD_WEBLOG_PREVIEW_BUTTON',_PREVIEW);
define('_MD_WEBLOG_POST_BUTTON','投稿');
define('_MD_WEBLOG_POST_BLOG','ブログ投稿');
define('_MD_WEBLOG_POST_PREVIEW','プレビュー');
define('_MD_WEBLOG_POST_TOO_SMALL','エントリは最低%d文字が必要です。あなたのエントリは%d文字です。内容を追加してください');
define('_MD_WEBLOG_CATEGORY_REQUIRED','カテゴリーが選択されていません。カテゴリーは必須項目です。');
define('_MD_WEBLOG_POST_TIMEOUT','エントリを%d分以内に投稿してください<em>*</em>');
define('_MD_WEBLOG_POST_MUST_BE','エントリは最低%d文字必要です<em>*</em>');
define('_MD_WEBLOG_CONTINUE_EDITING','編集を続ける');
define('_MD_WEBLOG_RSS_RECENT', '最新エントリ配信');
define('_MD_WEBLOG_RSS_RECENT_FOR', '%sさんのエントリ配信');
define('_MD_WEBLOG_UPDATEPING','更新Pingを送る');
define('_MD_WEBLOG_SPECIFY_TIME' , '公開日時を下記の時間で指定する') ;
define('_MD_WEBLOG_SPECIFY_TIME_DSC' , '&nbsp;&nbsp;&nbsp; 公開日時') ;
define('_MD_WEBLOG_TRACKBACK','トラックバックURL');
define('_MD_WEBLOG_TRACKBACKS','トラックバック数');
define('_MD_WEBLOG_TRACKBACK_DSC','トラックバックURLを複数記入する場合は改行で区切ってください。');
define('_MD_WEBLOG_TRACKBACK_ADMIN','受信したトラックバック');
//define('_MD_WEBLOG_COMMONPING_SERVERS',
//      'http://bulkfeeds.net/rpc|http://ping.bloggers.jp/rpc/|http://ping.myblog.jp/|http://blog.goo.ne.jp/XMLRPC');

define('_MD_WEBLOG_PERMISSION','閲覧可能グループ');
define('_MD_WEBLOG_PERMISSION_CAPTION','このエントリを閲覧できるグループを設定できます。');
define('_MD_WEBLOG_TRACKBACK_DELETE',_DELETE);
define('_MD_WEBLOG_GROUP_PERMIT', '申し訳ありませんが、このエントリは特定グループのみに閲覧権限が与えられています。');
define('_MD_WEBLOG_SELECT_ALL', 'すべて選択');
define('_MD_WEBLOG_CAUTION_NOHTML', '<strong>ご注意</strong>');
define('_MD_WEBLOG_FORBIDDEN_HTML_TAGS', 'HTMLタグは使えません<em>*</em>');


// %s is your site name
define('_MD_WEBLOG_INTARTICLE','%sで見つけた興味深いブログ');
define('_MD_WEBLOG_INTARTFOUND','以下は%sで見つけた非常に興味深いブログです：');

define('_MD_WEBLOG_PRINTERPAGE','印刷用ページ');
define('_MD_WEBLOG_SENDSTORY','友達に送る');

define('_MD_WEBLOG_POSTED', '投稿日時');
define('_MD_WEBLOG_AUTHOR', '執筆者');
// %s is your site name
define('_MD_WEBLOG_COMESFROM', '%sにて更に多くのブログを読むことができます。');
define('_MD_WEBLOG_PARMALINK', 'このブログのＵＲＬ');

// %s is count
define('_MD_WEBLOG_THEREAREINTOTAL', '計%s件のエントリがあります。');
define('_MD_WEBLOG_NOARCHIVEDESC', 'エントリはありません。');
define('_MD_WEBLOG_ARCHIVE', 'アーカイブ');
define('_MD_WEBLOG_RETRIEVE_ARCHIVES', 'アーカイブを検索する');
define('_MD_WEBLOG_ARCHIVE_LIST', 'アーカイブ');
define('_MD_WEBLOG_ARCHIVE_SUMMARY', 'このテーブルは過去のアーカイブをカテゴリー、投稿日順に一覧にした表です');
define('_MD_WEBLOG_ARCHIVE_FOR', '%sさん');
define('_MD_WEBLOG_ARCHIVE_OF_CATEGORY', '%s');
define('_MD_WEBLOG_ARCHIVE_OF_DATE', '%s');
define('_MD_WEBLOG_READS', '閲覧数');
define('_MD_WEBLOG_NEXT', '次のエントリ');
define('_MD_WEBLOG_PREV', '前のエントリ');

define('_MD_WEBLOG_SELECT_CATEGORY', 'カテゴリー選択');
// division separator
define('_MD_WEBLOG_ENTRY_SEPARATOR' , '前後半の区切り');
define('_MD_WEBLOG_ENTRY_SEPARATOR_CAPTION' , 'この区切り文字以降はエントリの詳細表示で閲覧できるようになります。');
define('_MD_WEBLOG_ENTRY_SEPARATOR_VALUE' , '区切り文字を入れるには、このボタンをクリック');
define('_MD_WEBLOG_ENTRY_SEPARATOR_NEXT' , '...続きを読む');
define('_MD_WEBLOG_ENTRY_SEPARATOR_WHOLE_ENTRY' , '全文を読む');

// member only delimeter
define('_MD_WEBLOG_MEMBER_ONLY_READ' , 'メンバーのみ閲覧');
define('_MD_WEBLOG_MEMBER_ONLY_READ_CAPTION' , 'この区切り文字以降はメンバーでないと読めないようになります。');
define('_MD_WEBLOG_MEMBER_ONLY_READ_VALUE' , '区切り文字を入れるには、このボタンをクリック');
define('_MD_WEBLOG_MEMBER_ONLY_READ_MORE' , 'このエントリを全て読むにはメンバー登録が必要です。');

// image manager tray
define('_MD_WEBLOG_WEBLOG_IMAGEMANAGER' , 'イメージマネージャ');
define('_MD_WEBLOG_WEBLOG_IMAGEMANAGER_CAUTION' , 'うぇブログ用イメージマネージャはPHPのGDモジュールがバージョン2以上で使用できます。');

// %s is trackback
define('_MD_WEBLOG_TRACKBACK_ANOUNCE' , 'トラックバックURL');
define('_MD_WEBLOG_GET_VALID_TRACKBACKURL' , 'トラックバックping送信用URLを取得する');
define('_MD_WEBLOG_TRACKBACK_TRANSMIT' , 'このエントリは以下のURLにトラックバックしています。');
define('_MD_WEBLOG_TRACKBACK_RECIEVED' , 'このエントリが受けたトラックバック');

// %s is uname
define('_MD_WEBLOG_TRACKBACKS_FOR',' (%sさんのエントリへ)');
define('_MD_WEBLOG_COMMENTS_FOR','(%sさんのエントリに)');

// structural
define('_MD_WEBLOG_SITE_NAVIGATION','サイトナビゲーション');
define('_MD_WEBLOG_PAGE_NAVIGATION','ページナビゲーション');
define('_MD_WEBLOG_FEED_NAVIGATION','RSSフィードナビゲーション');
define('_MD_WEBLOG_FEED_GUIDE','%s フィード');
define('_MD_WEBLOG_SITEWIDE_CATEGORY_NAVIGATION','サイト全体のカテゴリーナビゲーション');
define('_MD_WEBLOG_CURRENT_CATEGORY_NAVIGATION','現在のカテゴリー位置');
define('_MD_WEBLOG_THIS_BLOGS_CATEGORY','このブログのカテゴリー');
define('_MD_WEBLOG_READ_CATEGORY_OF','カテゴリー%sのエントリーを見る');
define('_MD_WEBLOG_BACK_FORWARD_NAVIGATION','前後エントリーへのナビゲーション');
define('_MD_WEBLOG_BACK_TO_PREVIOUS_ENTRY','前のエントリへ移動');
define('_MD_WEBLOG_GO_TO_NEXT_ENTRY','次のエントリへ移動');
define('_MD_WEBLOG_THIS_BLOGS_INFORMATION','このエントリーの情報');
define('_MD_WEBLOG_REMEMBER_THIS_BLOG','このエントリーの記録');
define('_MD_WEBLOG_HEADER_NAVIGATION','ヘッダーナビゲーション');
define('_MD_WEBLOG_FOOTER_NAVIGATION','フッターナビゲーション');
define('_MD_WEBLOG_LINK_TO_PAGE_OF','エントリ %s を読む');
define('_MD_WEBLOG_LINK_TO_OUTER_SITE_OF','外部サイト %s へジャンプ');
define('_MD_WEBLOG_SEE_PROFILE_OF','%sさんのプロフィールページへ');
define('_MD_WEBLOG_EDIT_THIS_ENTRY','このエントリーを編集する');
define('_MD_WEBLOG_READ_TRACKBACK_ON','%sのトラックバックを読む');
define('_MD_WEBLOG_READ_COMMENTS_ON','%sのコメントを読む');

// use weBLog imagemanager :: myalbum-P
define("_MD_WEBLOG_ALBM_PHOTOUPLOAD","画像アップロード");
define("_MD_WEBLOG_ALBM_MAXPIXEL","サイズ上限");
define("_MD_WEBLOG_ALBM_MAXSIZE","サイズ上限(byte)");
define("_MD_WEBLOG_ALBM_PHOTOTITLE","タイトル");
define("_MD_WEBLOG_ALBM_PHOTOCAT","カテゴリ");
define("_MD_WEBLOG_ALBM_SELECTFILE","画像選択");

define("_MD_WEBLOG_ALBM_PHOTODEL","画像を削除しますか?");
define("_MD_WEBLOG_ALBM_DELETINGPHOTO","削除中");
define("_MD_WEBLOG_ALBM_RECEIVED","画像を登録しました。ご投稿有難うございます。");
define("_MD_WEBLOG_ALBM_MUSTREGFIRST","申し訳ありませんがアクセス権限がありません。<br>登録するか、ログイン後にお願いします。");
define("_MD_WEBLOG_ALBM_NOIMAGESPECIFIED","画像未選択：アップロードすべき画像ファイルを選択して下さい。");
define("_MD_WEBLOG_ALBM_FILEERROR","画像アップロードに失敗：画像ファイルが見つからないか容量制限を越えてます。");
define("_MD_WEBLOG_ALBM_FILEREADERROR","画像読込失敗：なんらかの理由でアップロードされた画像ファイルを読み出せません。");

?>