<?php
/*
 * @version $Id: catmanager.php 202 2007-04-08 02:06:09Z hodaka $
 */

require_once dirname(dirname(__FILE__)).'/class/class.weblogcategories.php';
require_once dirname(dirname(__FILE__)).'/include/gtickets.php';
require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once dirname(dirname(__FILE__)).'/include/admin.inc.php';
include_once(sprintf('%s/class/xoopstree.php', XOOPS_ROOT_PATH));

$myts =& MyTextSanitizer::getInstance();
$db =& Database::getInstance() ;

$mytree = new XoopsTree($db->prefix($mydirname . '_category'), 'cat_id', 'cat_pid');

$action = (isset($_POST['action']))? $_POST['action'] : "" ;
$action = (isset($_GET['action']))?  $_GET['action']  : $action ;

switch ($action) {
    case "modCat":
    	$cat_id = (isset($_POST['cat_id'])) ? intval($_POST['cat_id']) : 0;
    	$modid = $xoopsModule->getVar('mid') ;

    	if( $cat_id ){
        	$cathandler =& xoops_getmodulehandler('category');
        	$gperm_handler =& xoops_gethandler('groupperm');
        	$count = $cathandler->getCount();
        	$weblogcats =& WeblogCategories::getInstance();
        	$wb_cat =& $cathandler->get($cat_id) ;
			$cat_pid = $wb_cat->getVar('cat_pid');
			$cat_title = $wb_cat->getVar('cat_title','s');
    	}else{
        	redirect_header('catmanager.php', 2, _MD_A_WEBLOG_CATNOTMODED);
			exit() ;
		}

    	xoops_cp_header();
		include dirname(__FILE__).'/mymenu.php';
   	 	echo sprintf('<h4>%s&nbsp;&raquo;&raquo;&nbsp;%s&nbsp;&raquo;&raquo;&nbsp;%s</h4>',
                 indexLink(), catManagerLink(), _MD_A_WEBLOG_MODCAT);

		include_once XOOPS_ROOT_PATH.'/class/xoopsformloader.php';
		$form_add = new XoopsThemeForm(_MD_A_WEBLOG_MODCAT, 'weblog_cat_form', 'catmanager.php') ;
		$form_add->addElement(new XoopsFormLabel(_MD_A_WEBLOG_CHOSECAT, $cat_title ) );
		$form_add->addElement(new XoopsFormText(_MD_A_WEBLOG_TITLE, 'cat_title', 50, 255, $cat_title), true);
		$form_add->addElement(new XoopsFormLabel(_MD_A_WEBLOG_PCAT, $weblogcats->getMySelectBox($cat_pid, 1, 'cat_pid')) );
		if( isset($xoopsModuleConfig['category_post_permission']) && $xoopsModuleConfig['category_post_permission'] ){
			$form_add->addElement(new XoopsFormSelectGroup(_MD_A_WEBLOG_CAT_GPERM, 'postgroup', true,
				$gperm_handler->getGroupIds('weblog_cat_post', $cat_id, $modid), 5, true));
		}
		$form_add->addElement(new XoopsFormHidden('cat_id', $cat_id));
		$form_add->addElement(new XoopsFormHidden('action', 'modCatS'));
		$form_add->addElement(new XoopsFormLabel(_MD_A_WEBLOG_CAT_OPERATE, sprintf('<input type=submit value=\'%s\'>', _MD_A_WEBLOG_MODIFY) . "&nbsp;" .
        	sprintf('<input type=button value=\'%s\' onClick="location=\'catmanager.php?cat_pid=%d&amp;cat_id=%d&amp;action=delCat\'">',
            _MD_A_WEBLOG_DELETE, $wb_cat->getVar('cat_pid'), $wb_cat->getVar('cat_id') ) . "&nbsp;" .
            sprintf('<input type=button value="%s"  onclick="location=\'catmanager.php\'" />', _MD_A_WEBLOG_CANCEL)));

		$form_add->display();

    	xoops_cp_footer();

        break;

    case "modCatS":
        modifyCategoryS($_POST);
        break;
    case "modCatall":
        include_once  dirname(dirname(__FILE__)).'/admin/mygroupperm.php';
		redirect_header( 'catmanager.php' , 1 , _MD_A_WEBLOG_GPERMUPDATED );
        break;
    case "addCat":
        addCategory($_POST);
        break;
    case "delCat":
    	$cat_handler =& xoops_getmodulehandler('category');
    	$gperm_handler =& xoops_gethandler('groupperm');

    	if ( !isset($_POST['ok']) || $_POST['ok'] != 1 ) {
        	$category =& $cat_handler->get(intval($_GET['cat_id']));
        	xoops_cp_header();
        	require_once dirname(__FILE__).'/mymenu.php';

        	xoops_confirm(array('action' => 'delCat', 'cat_id' => intval($_GET['cat_id']), 'ok' => 1),
                      'catmanager.php', sprintf(_MD_A_WEBLOG_DELCONFIRM, $category->getVar('cat_title')));
        	xoops_cp_footer();
    	} else {
			require_once dirname(dirname(__FILE__)).'/class/entry.php';
        	$entry_handler =& xoops_getmodulehandler('entry');
        	$id_arr = $cat_handler->getAllChildrenIds(intval($_POST['cat_id']));

        	array_push($id_arr, intval($_POST['cat_id']));
        	foreach ($id_arr as $id) {
            	$criteria = new criteria('cat_id', $id);
            	$entries = $entry_handler->getObjects($criteria);
            	foreach ($entries as $entry) {
                	if ($entry_handler->delete($entry)) {
                    	xoops_comment_delete($xoopsModule->getVar('mid'),
                                         $entry->getVar('blog_id'));
                    	xoops_notification_deletebyitem($xoopsModule->getVar('mid'),
                                                    'blog_entry', $entry->getVar('blog_id'));
                	}
            	}
            	$category =& $cat_handler->create();
            	$category->setVar('cat_id', $id);
            	$cat_handler->delete($category);	// delete category
            	$gperm_handler->deleteByModule($xoopsModule->getVar('mid'), 'weblog_cat_post', $id) ;	// delete gperm
/******
            xoops_notification_deleteitem($xoopsModule->getVar('mid'), 'category', $id);
******/
        	}
        	redirect_header('catmanager.php', 2, _MD_A_WEBLOG_CATDELETED);
       		exit();
    	}

        break;

    default:
		require_once dirname(__FILE__).'/mygrouppermform.php';

    	xoops_cp_header();
		include dirname(__FILE__).'/mymenu.php';

    	echo sprintf('<h4>%s&nbsp;&raquo;&raquo;&nbsp;%s</h4>', indexLink(), _MD_A_WEBLOG_CATMANAGER);

    	$gperm_handler =& xoops_gethandler('groupperm');
	
		$weblogcats =& WeblogCategories::getInstance();

//    $mytree->makeMySelBox('cat_title', 'cat_title');
	
		include_once XOOPS_ROOT_PATH.'/class/xoopsformloader.php';
		$form_add = new XoopsThemeForm(_MD_A_WEBLOG_ADDCAT, 'weblog_cat_form', 'catmanager.php');
		$form_add->addElement(new XoopsFormText(_MD_A_WEBLOG_TITLE, 'cat_title', 50, 255, ''), true);
		$form_add->addElement(new XoopsFormLabel(_MD_A_WEBLOG_PCAT, $weblogcats->getMySelectBox(0 , 1, 'cat_pid')) );
		if( isset($xoopsModuleConfig['category_post_permission']) && $xoopsModuleConfig['category_post_permission'] ){
			$form_add->addElement(new XoopsFormSelectGroup(_MD_A_WEBLOG_CAT_GPERM, 'postgroup', true, '' , 5, true));
		}
		$form_add->addElement(new XoopsFormHidden('action', 'addCat'));
		$form_add->addElement(new XoopsFormButton('', 'catadd_button', _SUBMIT, 'submit'));
		$form_add->display();

		$form_mod = new XoopsThemeForm(_MD_A_WEBLOG_MODCAT, 'weblog_cat_form', 'catmanager.php');
		$form_mod->addElement(new XoopsFormLabel(_MD_A_WEBLOG_CAT, $weblogcats->getMySelectBox(0, 0, 'cat_id')));
		$form_mod->addElement(new XoopsFormButton('', 'catmod_button', _MD_A_WEBLOG_GO, 'submit'));
		$form_mod->addElement(new XoopsFormHidden('action', 'modCat'));
		$form_mod->display();

		// All category permit list
		if( isset($xoopsModuleConfig['category_post_permission']) && $xoopsModuleConfig['category_post_permission'] ){
			$wb_cat_array = $weblogcats->getChildTreeArray();

			$global_perms_array = array();
			foreach( $wb_cat_array as $category_data ){
				$global_perms_array[$category_data['cat_id']] = $category_data['cat_title'] ;
			}
			$form_catgperm = new MyXoopsGroupPermForm( '' , $xoopsModule->mid() , 'weblog_cat_post' , "<br /><hr /><br /><h4>"._MD_A_WEBLOG_CAT_SETALL."</h4>" ) ;
			foreach( $global_perms_array as $perm_id => $perm_name ) {
				$form_catgperm->addItem( $perm_id , $perm_name ) ;
			}
			$form_catgperm->addElement(new XoopsFormHidden('action', 'modCatall')) ;
			echo $form_catgperm->render() ;
		}

    	xoops_cp_footer();
        break;
}

function &getCategory($post) {
    $handler =& xoops_getmodulehandler('category');
    $cat = $handler->create();

    $cat->setVar('cat_pid', (isset($post['cat_pid']))?intval($post['cat_pid']):0);
    $cat->setVar('cat_id', (isset($post['cat_id']))?intval($post['cat_id']):0);
    $cat->setVar('cat_created', (isset($post['cat_created']))?intval($post['cat_created']):time());
    $cat->setVar('cat_title', (isset($post['cat_title']))?$post['cat_title']:"");
    $cat->setVar('cat_description', (isset($post['desc']))?$post['desc']:"");
    $cat->setVar('cat_imgurl', (isset($post['imgurl']))?$post['imgurl']:"");
    $cat->setVar('postgroup', (isset($post['postgroup']))?$post['postgroup']:array());

    return $cat;
}

function catManagerLink() {
    global $xoopsModule;

    return sprintf('<a href=\'%s/modules/%s/admin/catmanager.php\'>%s</a>',
                   XOOPS_URL, $xoopsModule->dirname(), _MD_A_WEBLOG_CATMANAGER);
}

function addCategory($post) {
	global $xoopsModule ;

	$modid = $xoopsModule->getVar('mid') ;

    $cat = getCategory($post);
    if (strlen(trim($cat->getVar('cat_title', 'n')))<1) {
        redirect_header('catmanager.php', 2, _MD_A_WEBLOG_ERRORTITLE);
        exit();
    }
    $cat->setVar('cat_created', time());
    $cat_handler =& xoops_getmodulehandler('category');
    $ret = $cat_handler->insert($cat);	// insert category to weblog_category
	if( $ret ){	// insert group_permission
		$cat_id = $cat_handler->db->getInsertId();
		$postgroup = $cat->vars['postgroup']['value'] ; 
		$ret_gperm = true ;
		if( is_array($postgroup) && ! empty($postgroup) ){
			$gperm_handler =& xoops_gethandler('groupperm');
			foreach($postgroup as $group_id){
				$gperm =& $gperm_handler->create();
				$gperm->setVar('gperm_groupid', $group_id);
				$gperm->setVar('gperm_name', "weblog_cat_post");
				$gperm->setVar('gperm_modid', $modid);
				$gperm->setVar('gperm_itemid', $cat_id);
				if (!$gperm_handler->insert($gperm)) {
					$ret_gperm = false ;
				}
			}
		}
	}

    if ($ret && $ret_gperm) {
        redirect_header('catmanager.php', 2, _MD_A_WEBLOG_NEWCATADDED);
    } else {
        redirect_header('catmanager.php', 2, _MD_A_WEBLOG_CATNOTADDED);
    }
}

function modifyCategoryS($post) {
    global $xoopsModule ;

    $modid = $xoopsModule->getVar('mid') ;

    $cat = getCategory($post);

    if (strlen(trim($cat->getVar('cat_title', 'n')))<1) {
        redirect_header('catmanager.php', 2, _MD_A_WEBLOG_ERRORTITLE);
        exit();
    }
    $handler =& xoops_getmodulehandler('category');
    $ret = $handler->insert($cat);

	if( $ret ){	// insert group_permission
		$postgroup = $cat->vars['postgroup']['value'] ; 
		$ret_gperm = true ;
		if( is_array($postgroup) && ! empty($postgroup) ){
			$gperm_handler = xoops_gethandler('groupperm');
			if( false != $gperm_handler->deleteByModule($modid, 'weblog_cat_post', $cat->getVar('cat_id')) ){
				foreach($postgroup as $group_id){
					$gperm =& $gperm_handler->create();
					$gperm->setVar('gperm_groupid', $group_id);
					$gperm->setVar('gperm_name', "weblog_cat_post");
					$gperm->setVar('gperm_modid', $modid);
					$gperm->setVar('gperm_itemid', $cat->getVar('cat_id'));
					if (!$gperm_handler->insert($gperm)) {
						$ret_gperm = false ;
					}
				}
			}
		}
	}
    if ($ret && $ret_gperm) {
        redirect_header('catmanager.php', 2, _MD_A_WEBLOG_CATMODED);
    } else {
        redirect_header('catmanager.php', 2, _MD_A_WEBLOG_CATNOTMODED);
    }
}

?>