<?php
/**
 * @version $Id: blocks.php 280 2007-06-05 02:57:36Z hodaka $
 */

$mytrustdirname = basename( dirname( __FILE__ ) ) ;
$mytrustdirpath = dirname( __FILE__ ) ;

// language files
$langmanpath = XOOPS_TRUST_PATH.'/libs/altsys/class/D3LanguageManager.class.php' ;
if( ! file_exists( $langmanpath ) ) die( 'install the latest altsys' ) ;
require_once( $langmanpath ) ;
$langman =& D3LanguageManager::getInstance() ;
$langman->read( 'blocks_common.php' , $mydirname , $mytrustdirname ) ;
$langman->read( 'blocks_each.php' , $mydirname , $mytrustdirname , false ) ;

if(!function_exists('b_'.strtolower($mytrustdirname).'_category_list_show')) {
    // include all block files
    $block_path = $mytrustdirpath.'/blocks' ;

    if( $handler = @opendir( $block_path . '/' ) ) {
        while( ( $file = readdir( $handler ) ) !== false ) {
            if( substr( $file , 0 , 1 ) == '.' ) continue ;
            $file_path = $block_path . '/' . $file ;
            if( is_file( $file_path ) && substr( $file , -4 ) == '.php' ) {
                include_once $file_path ;
            }
        }
    }
}

global $xoopsTpl;
if(is_object($xoopsTpl)) {
    // assign block_header
    $css_file_name = 'block.css';
    $css_file_url = XOOPS_URL.'/modules/'.$mydirname.'/css/'.$css_file_name;
    $css_file_path = XOOPS_ROOT_PATH.'/modules/'.$mydirname.'/css/'.$css_file_name;
    $iecss_file_name = 'blockIE.css';
    $iecss_file_url = XOOPS_URL.'/modules/'.$mydirname.'/css/'.$iecss_file_name;
    $iecss_file_path = XOOPS_ROOT_PATH.'/modules/'.$mydirname.'/css/'.$iecss_file_name;
    if(is_file($css_file_path)) {
        $metalink = sprintf('<link rel="stylesheet" type="text/css" media="all" href="%s" />', $css_file_url);
        if(is_file($iecss_file_path)) {
            $ieworkaround = <<<DOC_END
<!--[if lt IE 7]>
%s
<![endif]-->\n
DOC_END;
            $metalink .= "\n".sprintf($ieworkaround, sprintf('<link rel="stylesheet" type="text/css" media="all" href="%s" />' , $iecss_file_url));
                
        }
        if(!$xoops_block_header = $xoopsTpl->get_template_vars('xoops_block_header')) {
            $xoopsTpl->assign('xoops_block_header', $metalink);
        } else {
            $xoopsTpl->assign('xoops_block_header', $xoops_block_header.$metalink);
        }
    }
}
?>