<?php
/**
 * $Id: blocks_archive.php 266 2007-05-26 08:07:27Z hodaka $
 * create weblog archive block
 * @author hodaka <hodaka@kuri3.net>
 * @copyright hodaka <hodaka@kuri3.net>
 */

// $options[0] is always weblog dirname.

//$mytrustdirname = basename(basename( dirname( __FILE__ )));

eval('
function b_'.strtolower($mytrustdirname).'_archive_show($options)
{
    return b_weblogd3_archive_show_base($options) ;
}
');

if( ! function_exists( 'd_weblogd3_archive_show_base' )) {
    
function b_weblogd3_archive_show_base($options) {
	global $xoopsDB, $xoopsUser;
	global $xoopsConfig;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
	$numperblock = $options[1];
    $this_template = empty( $options[2] ) ? 'db:'.$mydirname.'_block_archive.html' : trim( $options[2] ) ;

	$constpref = '_MB_' . strtoupper( $mydirname ) ;
	$offset = isset($_GET['offset'])? intval($_GET['offset']) : 0;
	$user_id = isset($_GET['user_id'])? intval($_GET['user_id']) : 0;
	$currentuid = is_object($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

	if(!defined('_CAL_SUNDAY')) {
		if (file_exists(XOOPS_ROOT_PATH.'/language/'.$xoopsConfig["language"].'/calendar.php')) {
			require_once XOOPS_ROOT_PATH.'/language/'.$xoopsConfig["language"].'/calendar.php';
		} else {
			require_once XOOPS_ROOT_PATH.'/language/english/calendar.php';
		}
	}
	$month_arr = array(1 => _CAL_JANUARY, 2 => _CAL_FEBRUARY, 3 => _CAL_MARCH, 4 => _CAL_APRIL, 5 => _CAL_MAY, 6 => _CAL_JUNE,
    7 => _CAL_JULY, 8 => _CAL_AUGUST, 9 => _CAL_SEPTEMBER, 10 => _CAL_OCTOBER, 11 => _CAL_NOVEMBER, 12 => _CAL_DECEMBER);
	
	$sql = "select FROM_UNIXTIME(created+". $useroffset*3600 .", '%Y%m') as thismonth, count(*) as entries from ".$xoopsDB->prefix($mydirname.'_entry');
	$sql .= " where user_id=$currentuid or (private='N' and created < ".time().")";
	$sql .= " group by thismonth";
	$sql .= " order by thismonth DESC";

	$block = array();
	$count = $xoopsDB->getRowsNum( $xoopsDB->query($sql) );
	$lines = $xoopsDB->query($sql, $numperblock, $offset);
	
	$archives = array();
	$i = 0;
	$months = array();
	while($line = $xoopsDB->fetchArray($lines)) {
		//$months[$i]['date'] = $line['thismonth']."00";
		$months[$i]['year'] = strval(substr($line['thismonth'], 0, 4));
		$months[$i]['month'] = strval(substr($line['thismonth'], 4, 2));
		$months[$i]['monthname'] = $month_arr[intval(substr($line['thismonth'], 4, 2))];
		$months[$i]['entries'] = $line['entries'];
		$i++;
	}
	$archives['months'] = $months; 
	// add page navigator if entries > per page
	if( $count > $numperblock ) {
		if( !empty($_SERVER['QUERY_STRING'])) {
			if( ereg("^offset=[0-9]+$", $_SERVER['QUERY_STRING']) ) {
				$url = "";
			} else {
				$url = preg_replace("/^(.*)\&offset=[0-9]+$/", "$1", $_SERVER['QUERY_STRING']);
			}
		} else {
			$url = "";
		}
		include_once XOOPS_ROOT_PATH.'/class/pagenav.php';
		$nav = new XoopsPageNav($count, $numperblock, $offset, "offset", $url);
		$archives['navigation'] = $nav->renderNav();
	} else {
		$archives['navigation'] = "";
	}
	$archives['module_dirname'] = $mydirname;
	$archives['currentuid'] = $currentuid;
	$archives['user_id'] = $user_id;
	$archives['lang_sort_archives'] = constant($constpref.'_LANG_SORT_ARCHIVE');

	$block['archives'] = $archives;
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;
}
}
eval('
function b_'.strtolower($mytrustdirname).'_archive_edit($options)
{
    return b_weblogd3_archive_edit_base($options) ;
}
');

if( ! function_exists( 'd_weblogd3_archive_edit_base' )) {
    
function b_weblogd3_archive_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;

    $form  = '<table>';
    $form .= "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
    $form .= sprintf('<tr><td><b>%s</b>:</td><td><input type="text" name="options[]" value="%d" /></td></tr>',
                     _MB_WEBLOG_EDIT_ARCHIVE_NUMBER_PER_PAGE, intval($options[1]));
    $form .= '</table>';
    return $form;
}
}

eval('
function b_'.strtolower($mytrustdirname).'_calendar_show($options)
{
    return b_weblogd3_calendar_show_base($options) ;
}
');

if( ! function_exists( 'd_weblogd3_calendar_show_base' )) {
    
function b_weblogd3_calendar_show_base($options) {
	global $xoopsDB, $xoopsUser;
	global $xoopsConfig, $xoopsTpl;

	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;
    $this_template = empty( $options[4] ) ? 'db:'.$mydirname.'_block_calendar.html' : trim( $options[4] ) ;
	$constpref = '_MB_' . strtoupper( $mydirname ) ;

	//include_once XOOPS_ROOT_PATH . '/modules/' . $mydirname . '/include/PEAR/Date/Calc.php' ;
	require_once dirname(dirname(__FILE__)).'/include/PEAR/Date/Calc.php';

	$currentuid = is_object($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

	if (is_object($xoopsUser)) {
		$useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;
	} else {
		$useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; ;
	}

	// set when month
	$date = ( isset($_GET['date']) && strlen(intval($_GET['date'])) >= 6 ) ? intval($_GET['date']) : '' ;
	if( $date > 0 ){
		$month = substr( $date , 0 , 6 ) ;
	}else{
		$month = date('Ym' , time() + $useroffset*3600 );
	}
	// get next/previous month and year
	$this_year = substr(strval($month) , 0 , 4) ;
	$this_month = substr(strval($month) , 4 , 6) ;
	$month_next = Date_Calc::beginOfNextMonth('1',$this_month,$this_year,$format='%Y%m') ;
	$month_prev = Date_Calc::beginOfPrevMonth('1',$this_month,$this_year,$format='%Y%m') ;
	$year_next = strval($this_year + 1) . $this_month ;
	$year_prev = strval($this_year - 1) . $this_month ;

	if(!defined('_CAL_SUNDAY')) {
		if (file_exists(XOOPS_ROOT_PATH.'/language/'.$xoopsConfig["language"].'/calendar.php')) {
			require_once XOOPS_ROOT_PATH.'/language/'.$xoopsConfig["language"].'/calendar.php';
		} else {
			require_once XOOPS_ROOT_PATH.'/language/english/calendar.php';
		}
	}
	$month_arr = array(1 => _CAL_JANUARY, 2 => _CAL_FEBRUARY, 3 => _CAL_MARCH, 4 => _CAL_APRIL,
						5 => _CAL_MAY, 6 => _CAL_JUNE, 7 => _CAL_JULY, 8 => _CAL_AUGUST,
						9 => _CAL_SEPTEMBER, 10 => _CAL_OCTOBER, 11 => _CAL_NOVEMBER, 12 => _CAL_DECEMBER
						);

	$week_arr = array( constant($constpref.'_LANG_SUNDAY'), constant($constpref.'_LANG_MONDAY'), constant($constpref.'_LANG_TUESDAY'),
						constant($constpref.'_LANG_WEDNESDAY'), constant($constpref.'_LANG_THURSDAY'), constant($constpref.'_LANG_FRIDAY'), constant($constpref.'_LANG_SATURDAY'));
		
	// get one month calendar array
	require_once dirname(dirname(__FILE__)).'/class/class.calendar.php';
	$mycalendar = new MyCalendar($month);
	$calendar = $mycalendar->dispCalendar();

    $calendar['lang_calendar_summary'] = constant($constpref.'_SUMMARY_CALENDAR');
	$calendar['lang_monthPrev'] = constant($constpref.'_LANG_PREVMONTH');
	$calendar['lang_monthNext'] = constant($constpref.'_LANG_NEXTMONTH');
	$calendar['lang_yearPrev'] = constant($constpref.'_LANG_PREVYEAR');
	$calendar['lang_yearNext'] = constant($constpref.'_LANG_NEXTYEAR');	
	$calendar['lang_month'] = $month_arr[intval($calendar['month'])];
	$calendar['lang_ShowPrevMonth'] = constant($constpref.'_LANG_PREVMONTH_TITLE');
	$calendar['lang_ShowNextMonth'] = constant($constpref.'_LANG_NEXTMONTH_TITLE');
	$calendar['lang_ShowPrevYear'] = constant($constpref.'_LANG_PREVYEAR_TITLE');
	$calendar['lang_ShowNextYear'] = constant($constpref.'_LANG_NEXTYEAR_TITLE');
	$calendar['lang_ShowThisMonth'] = constant($constpref.'_LANG_THIS_MONTH_TITLE');
	$calendar['dayofweek'] = $week_arr;
	// override
	$calendar['monthThis'] = $this_year . $this_month ;
	$calendar['monthPrev'] = $month_prev ;
	$calendar['monthNext'] = $month_next ;
	$calendar['yearPrev'] = $year_prev ;
	$calendar['yearNext'] = $year_next ;
	
	if(!empty($_SERVER['QUERY_STRING'])) {

		if(ereg("^calMonth=[0-9]{10}$",$_SERVER['QUERY_STRING'])) {
			$query_string = "?";
		}
		else {
			$query_string = "?".preg_replace("/(.*)\&calMonth=[0-9]{10}$/", "$1", $_SERVER['QUERY_STRING'])."&";
		}
	}
	else {
		$query_string = "?";
	}
	$calendar['action_url'] = $_SERVER['PHP_SELF'].$query_string;


	// set the month
	$yearmonth = date('Ym',$calendar['monthThis']);
	$calendar['yearmonth'] = $yearmonth;
		
	// get entries of the month
	$sql = "select FROM_UNIXTIME(created+" . $useroffset*3600 . ", '%d') as day, blog_id from ".$xoopsDB->prefix($mydirname.'_entry');
	$sql .= " where (FROM_UNIXTIME(created+". $useroffset*3600 .", '%Y%m') = ".$month.") ";
	$sql .= " and ((private='N' and created < ".time().") or user_id=$currentuid)";
	$sql .= " group by day " ;
	$sql .= " order by day ASC";
	$lines = $xoopsDB->query($sql);
	
	$entries = array();
	if($lines) {
		while( list($day, $blog_id) = $xoopsDB->fetchRow($lines) ) {
//			$entries[$blog_id] = intval($day);
			$entries[intval($day)] = $this_year . $this_month . $day;
		}
	}
	$days = array_keys($entries);			// make array of day
//	$counts = array_count_values($days);	// make day=>count array
//	$entries = array_flip($entries);		// make day=>blog_id array

	// week number of 1st day of this month
	$firstcol = date("w", mktime(0, 0, 0, $this_month, 1, $this_year) );
	// insert entry count corresponding to the day
	foreach($entries as $day => $yyyymmdd) {
		$row = ceil( ($day + $firstcol) / 7 ) - 1;
		$col = date("w", mktime(0, 0, 0, $this_month, $day, $this_year));
		$calendar['details'][$row][$col] = $yyyymmdd ;
		
	}

// optional variables in case you want to replace prev and next month to the months posted any entries
// prev month to show 
/*	$sql = "select FROM_UNIXTIME(created, '%Y%m') as prevmonth from ".$xoopsDB->prefix($mydirname.'_entry');
	$sql .= " where (private='N' or (private='Y' and user_id=$currentuid))";
	$sql .= " and FROM_UNIXTIME(created, '%Y%m') < $yearmonth";
	$sql .= " group by prevmonth";
	$sql .= " order by prevmonth DESC";
	$sql .= " limit 0, 1";
	$result = $xoopsDB->query($sql);
	if($result) {
		list($calendar['prevMonthPosted']) = $xoopsDB->fetchRow($result);
	} else {
		$calendar['prevMonthPosted'] = "";
	}*/
// next month to show
/*	if( $yearmonth < date( 'Ym', time() ) ) {
		$sql = "select FROM_UNIXTIME(created, '%Y%m') as nextmonth from ".$xoopsDB->prefix($mydirname.'_entry');
		$sql .= " where (private='N' or (private='Y' and user_id=$currentuid))";
		$sql .= " and FROM_UNIXTIME(created, '%Y%m') > $yearmonth";
		$sql .= " group by nextmonth";
		$sql .= " order by nextmonth ASC";
		$sql .= " limit 0, 1";
		$result = $xoopsDB->query($sql);
		if($result) {
			list($calendar['nextMonthPosted']) = $xoopsDB->fetchRow($result);
		} else {
			$calendar['nextMonthPosted'] = "";
		}
	} else {
		$calendar['nextMonthPosted'] = "";
	}*/

	$calendar['moduledir'] = $mydirname;
//	$calendar['calblockcss'] = 'db:'.$mydirname . '_calblock.css.html';
	$calendar['user_id'] = isset($_GET['user_id'])? intval($_GET['user_id']) : 0;
	$block['calendar'] = $calendar;
    $tpl =& new XoopsTpl();
	$tpl->assign( 'block' , $block );
	$ret['content'] = $tpl->fetch( $this_template );
	return $ret;	
}
}
eval('
function b_'.strtolower($mytrustdirname).'_calendar_edit($options)
{
    return b_weblogd3_calendar_edit_base($options) ;
}
');

if( ! function_exists( 'd_weblogd3_calendar_edit_base' )) {
    
function b_weblogd3_calendar_edit_base($options) {
	$mydirname = empty( $options[0] ) ? 'weblogD3' : $options[0] ;
	if( preg_match( '/[^0-9a-zA-Z_-]/' , $mydirname ) ) die( 'Invalid dirname' ) ;

    $form = "<input type='hidden' name='options[]' value='$mydirname' />\n" ;
	return $form ;
}
}
?>