<?php
/**
 * $Id: admin.php 170 2007-03-22 09:26:12Z hodaka $
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.zive.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place
 */
if( defined( 'FOR_XOOPS_LANG_CHECKER' ) || ! defined( 'WEBLOG_AM_LOADED' ) ) {

include_once XOOPS_ROOT_PATH."/class/xoopsmodule.php";
$mydirname = basename(dirname(dirname(dirname( __FILE__ )))) ;
$xoopsModule =& XoopsModule::getByDirname($mydirname);
//global $xoopsModule ;

define( 'WEBLOG_AM_LOADED' , 1 ) ;

define('_MD_A_WEBLOG_CONFIG', $xoopsModule->name().' Configuration');
define('_MD_A_WEBLOG_PREFERENCES', _PREFERENCES);
define('_MD_A_WEBLOG_PREFERENCESDSC', 'General Configuration.');
define('_MD_A_WEBLOG_GO', _GO);
define('_MD_A_WEBLOG_CANCEL', _CANCEL);
define('_MD_A_WEBLOG_DELETE', _DELETE);
define('_MD_A_WEBLOG_MODIFY', 'Change');
define('_MD_A_WEBLOG_TITLE', 'Title');

//define('_MD_A_WEBLOG_DBMANAGER', 'Database');
//define('_MD_A_WEBLOG_DBMANAGERDSC', 'Database utility that is basically for updating module.');
define('_MD_A_WEBLOG_IMPORTMANAGER', 'Import');
define('_MD_A_WEBLOG_IMPORTMANAGERDSC', 'Import DB, comments from the old/other weblog module');
define('_MD_A_WEBLOG_TABLE', 'Table');
define('_MD_A_WEBLOG_SYNCCOMMENTS', 'Synchronize comments count');
define('_MD_A_WEBLOG_SYNCCOMMENTSDSC', 'Correct count if you see # of comments of each entry wrong.<br />This might be because v1.02 or earlier version did not handle count correctly.');
define('_MD_A_WEBLOG_CHECKTABLE', 'Check tables structure');
define('_MD_A_WEBLOG_CHECKTABLEDSC', 'Check tables in database. You could checkNew version might require new tables or columns.');
define('_MD_A_WEBLOG_CREATETABLE', 'Create table \'%s\'');
define('_MD_A_WEBLOG_CREATETABLEDSC', 'Create a table named \'%s\'');

define('_MD_A_WEBLOG_ADD', 'Column \'%s\' not found');
define('_MD_A_WEBLOG_ADDDSC', 'Column \'<b>%s</b>\' is not found in the database table. This column is required for current version.<br />Press button to add this column to existing table.<br />Backing up your database is strongly recommended.');
define('_MD_A_WEBLOG_NOADD', 'Table \'%s\' is ready!');
define('_MD_A_WEBLOG_NOADDDSC', 'Table \'%s\' is ready to be used for current version. You do not have to warry anything about the table.');
define('_MD_A_WEBLOG_DBUPDATED', 'Database updated successfully!');
define('_MD_A_WEBLOG_UNSUPPORTED', 'Error: Not supported request');
define('_MD_A_WEBLOG_TABLEADDED', 'New table created successfully!');
define('_MD_A_WEBLOG_TABLENOTADDED', 'Error: Table could not created: %s');
define('_MD_A_WEBLOG_COLADDED', 'New column added successfully!');
define('_MD_A_WEBLOG_COLNOTADDED', 'Error: Column could not added: %s');

define('_MD_A_WEBLOG_H2_IMPORTFROM', 'Import Manager');
define('_MD_A_WEBLOG_H3_IMPORTDATABASE', 'Database copy');
define('_MD_A_WEBLOG_H3_IMPORTIMAGES', 'move posted images to the new directory');
define('_MD_A_WEBLOG_H3_IMPORTCOM', 'Import comments and notifications');
define('_MD_A_WEBLOG_H3_SYNCHRONIZE', 'Re-calculate number of comments and trackbacks');
define('_MD_A_WEBLOG_LABEL_SELECTMODULE', 'Copy from');
define('_MD_A_WEBLOG_LABEL_SELECTDIRECTORY', 'Move from');
define('_MD_A_WEBLOG_LABEL_NEWPHOTODIRECTORY', 'Directory for main image');
define('_MD_A_WEBLOG_LABEL_NEWTHUMBDIRECTORY', 'Directory for thumbnail');
define('_MD_A_WEBLOG_LANG_SELECT_IMPORTMODULE', 'Select the module');
define('_MD_A_WEBLOG_BTN_DOIMPORT', 'Start to copy');
define('_MD_A_WEBLOG_CONFIRM_DOCOMIMPORT', 'Are you sure to import comments and notification?');
define('_MD_A_WEBLOG_BTN_DOIMAGEIMPORT', 'Start to move');
define('_MD_A_WEBLOG_BTN_DOSYNCHRONIZE', 'Start to re-calculate');
define('_MD_A_WEBLOG_CONFIRM_DOIMPORT', 'Are you sure to copy?');
define('_MD_A_WEBLOG_CONFIRM_DOIMAGEIMPORT', 'Are you sure to move');
define('_MD_A_WEBLOG_CONFIRM_DOSYNCHRONIZE', 'Are you sure to re-calculate?');
define('_MD_A_WEBLOG_HELP_IMPORTFROM', '<p>Database tables will be copied from the selected module. Original table data is kept alive only if you don\'t uninstall the original module.</p>'.
    '<p><strong style="padding-right:1em">Notice</strong>No block, template and prefences are copied.</p>');
define('_MD_A_WEBLOG_HELP_COMIMPORT', '<p>Comments and notifications will be moved to this module.</p>'.
	'<p><strong style="padding-right:1em">Notice</strong>Re-calculate comments counts in entry table.</p>');
define('_MD_A_WEBLOG_HELP_IMPORTIMAGE', '<p>Posted images can be moved to this module image directory.</p>'.
    '<p><strong style="padding-right:1em">Notice</strong>No action is needed if you like images to keep in the old directory.<br />'.
    '<strong style="padding-right:1em">Notice</strong>Remember to check and modify a directory name in preferences admin panel in advance.<br />'.
	'<strong style="padding-right:1em">Notice</strong>Running on the safe_mode server or the permission denial occurence, you must move/remove images and directories by yourself.</p>');
define('_MD_A_WEBLOG_HELP_SYNCHRONIZE', '<p>Number of Comments and trackbacks can be synchronized.</p>'.
    '<p><strong style="padding-right:1em"></strong>Usefull to correct the numbers of comments and trackbacks after direct editing database by phpMyAdmin, etc.</p>');
define('_MD_A_WEBLOG_ERR_INVALIDMID', 'Invalid module id');
define('_MD_A_WEBLOG_ERR_SQLONIMPORT', 'Error: SQL error occured while accessing database');
define('_MD_A_WEBLOG_ERR_NO_MOVABLEPHOTO', 'No movable image in all the weblog modules.');
define('_MD_A_WEBLOG_MSG_IMPORTDONE', 'Database records copied successfully');
define('_MD_A_WEBLOG_MSG_MIGHT_REWRITE_LINKPATH', '</br />Don\'t foregt to re-write link paths in contents');
define('_MD_A_WEBLOG_MSG_IMAGEIMPORTDONE', 'Main images(%u), thumbnails(%u) are moved successfully');

define('_MD_A_WEBLOG_CATMANAGER', 'Categories');
define('_MD_A_WEBLOG_CATMANAGERDSC', 'Add/Modify/Delete Categories.');
define('_MD_A_WEBLOG_ADDCAT', 'Add Category');
define('_MD_A_WEBLOG_ADDMAINCAT', 'Add Main Category');
define('_MD_A_WEBLOG_ADDSUBCAT', 'Add Sub Category');
define('_MD_A_WEBLOG_CAT', 'Category');
define('_MD_A_WEBLOG_IMGURL', 'Image URL');
define('_MD_A_WEBLOG_ERRORTITLE', 'ERROR: You need to enter a TITLE!');
define('_MD_A_WEBLOG_NEWCATADDED', 'New category added successfully!');
define('_MD_A_WEBLOG_CATNOTADDED', 'Category could not added!');
define('_MD_A_WEBLOG_CATMODED', 'Category modified successfully!');
define('_MD_A_WEBLOG_CATNOTMODED', 'Category could not modified!');
define('_MD_A_WEBLOG_MODCAT', 'Modify Category');
define('_MD_A_WEBLOG_PCAT', 'Parent Category');
define('_MD_A_WEBLOG_CHOSECAT', 'Chosen Category');
define('_MD_A_WEBLOG_DELCONFIRM', 'Are you sure to delete category \'%s\' and its sub categories?<br />All entries that belong to those categories will be deleted.');
define('_MD_A_WEBLOG_CATDELETED', 'Category deleted successfully!');
define('_MD_A_WEBLOG_CAT_GPERM', 'Groups allowed to post this category');
define('_MD_A_WEBLOG_CAT_OPERATE', 'Operation');
define('_MD_A_WEBLOG_CAT_SETALL', 'Set group post permissions of all categories ');


define('_MD_A_WEBLOG_MYBLOCKSADMIN', 'Blocks and Groups');
define('_MD_A_WEBLOG_MYBLOCKSADMINDSC', 'Setting of Blocks and Groups');
define('_MD_A_WEBLOG_TEMPLATE_MANEGER', 'Templates');
define('_MD_A_WEBLOG_TEMPLATE_MANEGERDSC', 'Shortcut to Template manager');

define('_MD_A_WEBLOG_PRIVMANAGER_WEBLOG', 'Privileges (weBLog simple system)');
define('_MD_A_WEBLOG_PRIVMANAGER_WEBLOG_DSC', 'Control posting privilege.');
define('_MD_A_WEBLOG_PRIVMANAGER_WEBLOG_CAUTION', 'These setting parameters are valid when you choose "weBLog simple system" as Privilege manager with weBLog Preferences.');
define('_MD_A_WEBLOG_PRIVMANAGER_XOOPS', 'Privileges (XOOPS standerd system)');
define('_MD_A_WEBLOG_PRIVMANAGER_XOOPS_DSC', 'Control posting and reading privilege.');
define('_MD_A_WEBLOG_PRIVMANAGER_XOOPS_CAUTION', 'These setting parameters are valid when you choose "XOOPS standard system" as Privilege manager with weBLog Preferences.');
define('_MD_A_WEBLOG_ADDPRIV', _ADD);
define('_MD_A_WEBLOG_DELETEPRIV', _DELETE);
define('_MD_A_WEBLOG_NONPRIV', 'Non Privileged');
define('_MD_A_WEBLOG_PRIV', 'Privileged');

define('_MD_A_WEBLOG_GROUPPERM_GLOBAL' , 'Privilege manager for each groups' );
define('_MD_A_WEBLOG_GROUPPERM_GLOBALDESC' , 'Privilege Settings to every group. EDIT Privilege to Anonymous user is invalid.' );
define('_MD_A_WEBLOG_GPERMUPDATED' , 'Update group perameters' );
define('_MD_A_WEBLOG_PRIV_EDIT' , 'POST/EDIT/DELETE') ;
define('_MD_A_WEBLOG_PRIV_READINDEX' , 'READ ENTRY INDEX/RSS/RDF') ;
define('_MD_A_WEBLOG_PRIV_READDETAIL' , 'READ DETAIL ENTRY(details.php)') ;
define('_MD_A_WEBLOG_PERMADDOK' , 'Added %s permission to %s for group %s') ;
define('_MD_A_WEBLOG_PERMADDNG' , 'Could not add %s permission to %s for group %s') ;
define('_MD_A_WEBLOG_PERMRESETNG','Could not reset group permission for module %s');
define('_MD_A_WEBLOG_PERMADDNGP', 'All parent items must be selected.');
}
?>