<?php
/**
 * $Id: main.php 315 2007-07-09 05:44:24Z hodaka $
 * Copyright (c) 2003 by Jeremy N. Cowgar <jc@cowgar.com>
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.zive.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

if( defined( 'FOR_XOOPS_LANG_CHECKER' ) || ! defined( 'WEBLOG_MD_WEBLOG_LOADED' ) ) {

define( 'WEBLOG_MD_WEBLOG_LOADED' , 1 ) ;

// Basic's
define('_MD_WEBLOG_DISABLEHTML', _DISABLEHTML);
define('_MD_WEBLOG_WRAPLINES', 'Auto wrap lines');
define('_MD_WEBLOG_TITLE', 'Title');
define('_MD_WEBLOG_DESCRIPTION', 'Description');
define('_MD_WEBLOG_CATEGORY', 'Category');
define('_MD_WEBLOG_CATEGORIES', 'Categories');
define('_MD_WEBLOG_MAIN', 'Main');
define('_MD_WEBLOG_CONTENTS','Contents');
define('_MD_WEBLOG_POST','Post');
define('_MD_WEBLOG_PREVIEW',_PREVIEW);
define('_MD_WEBLOG_PRIVATE','Private');
define('_MD_WEBLOG_OPTIONS','Options');
define('_MD_WEBLOG_COMMENTS','Comments');
define('_MD_WEBLOG_READ_USERS_BLOG',"Read %s's weBLog");
define('_MD_WEBLOG_EDIT',_EDIT);
define('_MD_WEBLOG_READ','read');
define('_MD_WEBLOG_SHOW','show');
define('_MD_WEBLOG_DELETE',_DELETE);
define('_MD_WEBLOG_BLOG','weBLog');
define('_MD_WEBLOG_GATHERING','Gathering your weBLog entries now!');
define('_MD_WEBLOG_GATHERING_SORRY','Sorry, My weBLog is for registered users only.');
define('_MD_WEBLOG_PRIVATE_NOTEXIST_SORRY', 'Sorry, The entry you requested is private or does not exist.');
define('_MD_WEBLOG_ENTRY_POSTED','weBLog entry has been posted!');
define('_MD_WEBLOG_MOST_RECENT','Most recent entries');
define('_MD_WEBLOG_ENTRIES_FOR','Entries for %s');
define('_MD_WEBLOG_ENTRIES_FOR_DATE','Entries for date %s');
define('_MD_WEBLOG_ENTRIES_FOR_CATEGORY','Entries for category %s');
define('_MD_WEBLOG_ENTRY_FOR','Entry for %s');
define('_MD_WEBLOG_NUMBER_OF_READS','Reads');
define('_MD_WEBLOG_NUMBER_OF_TRACKBACKS','Trackback');
define('_MD_WEBLOG_CONFIRM_DELETE',"Are you sure you wish to remove weBLog entry '%s'?");
define('_MD_WEBLOG_BLOG_DELETED','Selected weBLog entry was deleted');
define('_MD_WEBLOG_BLOG_NOT_DELETED','Selected weBLog entry was not deleted. Insufficient rights?');
define('_MD_WEBLOG_WHOS_BLOG',"%s's weBLog");
define('_MD_WEBLOG_ANON_CANNOT_POST_SORRY','Sorry, Only permitted users can post weBLog entries.<br />Please contact webmasters if you would like to post entries.');
define('_MD_WEBLOG_CANNOT_READ_SORRY','Sorry, Only permitted users can read weBLog entries.<br />Please register or contact webmasters if you would like to read entries.');
define('_MD_WEBLOG_CANNOT_EDIT','Only Administrator or blogger who post this entry can edit.');
define('_MD_WEBLOG_DELETE_BUTTON',_DELETE);
define('_MD_WEBLOG_PREVIEW_BUTTON',_PREVIEW);
define('_MD_WEBLOG_POST_BUTTON','Post');
define('_MD_WEBLOG_POST_BLOG','Post entry');
define('_MD_WEBLOG_POST_PREVIEW','Preview');
define('_MD_WEBLOG_POST_TOO_SMALL','Entries must be at least %d charaters, yours is %d. Please add more content!');
define('_MD_WEBLOG_CATEGORY_REQUIRED','Category is empty. You must select the category.');
define('_MD_WEBLOG_POST_TIMEOUT','Entry must be posted in <em>%d</em> minutes');
define('_MD_WEBLOG_POST_MUST_BE','Entry must be at least <em>%d</em> charaters');
define('_MD_WEBLOG_CONTINUE_EDITING','Continue Editing');
define('_MD_WEBLOG_RSS_RECENT', 'Syndicate weBLogs');
define('_MD_WEBLOG_RSS_RECENT_FOR', "Syndicate %s's entries");
define('_MD_WEBLOG_UPDATEPING','Send update ping');
define('_MD_WEBLOG_SPECIFY_TIME' , 'Specify entry time as below') ;
define('_MD_WEBLOG_SPECIFY_TIME_DSC' , '&nbsp;&nbsp;&nbsp; set date') ;
define('_MD_WEBLOG_TRACKBACK','Trackback URL');
define('_MD_WEBLOG_TRACKBACKS','Trackbacks');
define('_MD_WEBLOG_TRACKBACK_DSC','Please fill trackback URLs set apart by new line');
define('_MD_WEBLOG_TRACKBACK_ADMIN','Recieved Trackback');
define('_MD_WEBLOG_PERMISSION','Readable Groups');
define('_MD_WEBLOG_PERMISSION_CAPTION','You can set which groups can read this entry.');
define('_MD_WEBLOG_TRACKBACK_DELETE',_DELETE);
define('_MD_WEBLOG_GROUP_PERMIT', "Sorry. You are not allowed to read this entry.");
define('_MD_WEBLOG_SELECT_ALL', 'Select all');
define('_MD_WEBLOG_CAUTION_NOHTML', '<b>Caution</b>');
define('_MD_WEBLOG_FORBIDDEN_HTML_TAGS', '<b>You cannot use HTML Tag</b>(Please use BB tags)');


// %s is your site name
define('_MD_WEBLOG_INTARTICLE','Interesting blog at %s');
define('_MD_WEBLOG_INTARTFOUND','Here is an interesting blog I have found at %s');

define('_MD_WEBLOG_PRINTERPAGE','Printer Friendly Page');
define('_MD_WEBLOG_SENDSTORY','Send this Blog to a Friend');

define('_MD_WEBLOG_POSTED', 'Posted');
define('_MD_WEBLOG_AUTHOR', 'Author');
// %s is your site name
define('_MD_WEBLOG_COMESFROM', 'This blog comes from %s');
define('_MD_WEBLOG_PARMALINK', 'The URL of this blog');

// %s is count
define('_MD_WEBLOG_THEREAREINTOTAL', '%s entrie(s) in archive.');
define('_MD_WEBLOG_NOARCHIVEDESC', 'No entries in archive.');
define('_MD_WEBLOG_ARCHIVE', 'Archives');
define('_MD_WEBLOG_RETRIEVE_ARCHIVES', 'Search and retrieve archives');
define('_MD_WEBLOG_ARCHIVE_LIST', 'Archive List');
define('_MD_WEBLOG_ARCHIVE_SUMMARY', 'This is a table which shows archive list by category and posted date order.');
define('_MD_WEBLOG_ARCHIVE_FOR', "%s's");
define('_MD_WEBLOG_ARCHIVE_OF_CATEGORY', '%s');
define('_MD_WEBLOG_ARCHIVE_OF_DATE', '%s');
define('_MD_WEBLOG_READS', 'Reads');
define('_MD_WEBLOG_NEXT', 'Next entry');
define('_MD_WEBLOG_PREV', 'Previous entry');

define('_MD_WEBLOG_SELECT_CATEGORY', 'Select category');
// division separator
define('_MD_WEBLOG_ENTRY_SEPARATOR' , 'Entry Separator');
define('_MD_WEBLOG_ENTRY_SEPARATOR_CAPTION' , 'This separator divides the first half and the latter half of entries. Full entry is shown at detail view');
define('_MD_WEBLOG_ENTRY_SEPARATOR_VALUE' , 'Click this button to insert separator');
define('_MD_WEBLOG_ENTRY_SEPARATOR_NEXT' , '...more');
define('_MD_WEBLOG_ENTRY_SEPARATOR_WHOLE_ENTRY' , 'Read whole this entry');

// member only delimeter
define('_MD_WEBLOG_MEMBER_ONLY_READ' , 'Only member');
define('_MD_WEBLOG_MEMBER_ONLY_READ_CAPTION' , 'Only member can read below this separator');
define('_MD_WEBLOG_MEMBER_ONLY_READ_VALUE' , 'Click this button to insert separator');
define('_MD_WEBLOG_MEMBER_ONLY_READ_MORE' , 'The member registration is necessary for you to read more.');

// image manager tray
define('_MD_WEBLOG_WEBLOG_IMAGEMANAGER' , 'Image Manager');
define('_MD_WEBLOG_WEBLOG_IMAGEMANAGER_CAUTION' , '"weBLog imagemanager requires PHP-GD2 extension. Your environment is not valid."');

// %s is trackback
define('_MD_WEBLOG_TRACKBACK_ANOUNCE' , 'Trackback URL of this entry');
define('_MD_WEBLOG_GET_VALID_TRACKBACKURL' , 'Get Valid Trackback ping URL');
define('_MD_WEBLOG_TRACKBACK_TRANSMIT' , 'This entry trackbacks to below URL');
define('_MD_WEBLOG_TRACKBACK_RECIEVED' , 'Trackbacks to this entry');
//define('_MD_WEBLOG_COMMONPING_SERVERS',
//		'http://bitacoras.com/directorio/ping.php|#http://ping.blo.gs/|#http://rpc.weblogs.com/RPC2|#http://rpc.technorati.com/rpc/ping');

// %s is uname
define('_MD_WEBLOG_TRACKBACKS_FOR','to %s\'s Entries ');
define('_MD_WEBLOG_COMMENTS_FOR','for %s\'s Entries ');

// structural
define('_MD_WEBLOG_SITE_NAVIGATION','Site Navigation');
define('_MD_WEBLOG_PAGE_NAVIGATION','Page Navigation');
define('_MD_WEBLOG_FEED_NAVIGATION','Feed navigation');
define('_MD_WEBLOG_FEED_GUIDE','%s feed');
define('_MD_WEBLOG_SITEWIDE_CATEGORY_NAVIGATION','Sitewide category navigation');
define('_MD_WEBLOG_CURRENT_CATEGORY_NAVIGATION','Current Category path');
define('_MD_WEBLOG_THIS_BLOGS_CATEGORY','Category of this entry');
define('_MD_WEBLOG_READ_CATEGORY_OF','Read entries of category %s');
define('_MD_WEBLOG_BACK_FORWARD_NAVIGATION','Back and forth navigation');
define('_MD_WEBLOG_BACK_TO_PREVIOUS_ENTRY','Move to previous entry');
define('_MD_WEBLOG_GO_TO_NEXT_ENTRY','Move to next entry');
define('_MD_WEBLOG_THIS_BLOGS_INFORMATION','This entry\'s information');
define('_MD_WEBLOG_REMEMBER_THIS_BLOG','Remember thid entry');
define('_MD_WEBLOG_HEADER_NAVIGATION','Page header navigation');
define('_MD_WEBLOG_FOOTER_NAVIGATION','Page footer navigation');
define('_MD_WEBLOG_LINK_TO_PAGE_OF','Link to read an entry %s');
define('_MD_WEBLOG_LINK_TO_OUTER_SITE_OF','Link to outer site %s');
define('_MD_WEBLOG_SEE_PROFILE_OF','Link to read %s\'s profile');
define('_MD_WEBLOG_EDIT_THIS_ENTRY','Edit this this entry');
define('_MD_WEBLOG_READ_TRACKBACK_ON','Read trackback on %s');
define('_MD_WEBLOG_READ_COMMENTS_ON','Read comments on %s');

// use weBLog imagemanager :: myalbum-P
define("_MD_WEBLOG_ALBM_PHOTOUPLOAD","Photo Upload");
define("_MD_WEBLOG_ALBM_MAXPIXEL","Max pixel size");
define("_MD_WEBLOG_ALBM_MAXSIZE","Max file size(byte)");
define("_MD_WEBLOG_ALBM_PHOTOTITLE","Title");
define("_MD_WEBLOG_ALBM_PHOTOCAT","Category");
define("_MD_WEBLOG_ALBM_SELECTFILE","Select photo");

define("_MD_WEBLOG_ALBM_PHOTODEL","Delete photo?");
define("_MD_WEBLOG_ALBM_DELETINGPHOTO","Deleting photo");
define("_MD_WEBLOG_ALBM_RECEIVED","We received your Photo. Thanks!");
define("_MD_WEBLOG_ALBM_MUSTREGFIRST","Sorry, you don't have the permission to perform this action.<br>Please register or login first!");
define("_MD_WEBLOG_ALBM_NOIMAGESPECIFIED","Error: No photo is uploaded");
define("_MD_WEBLOG_ALBM_FILEERROR","Error: Photos are too big or some troubles about configuration has occurred");
define("_MD_WEBLOG_ALBM_FILEREADERROR","Error: Photos are not readable.");

}
?>