<?php
/**
 * $Id: modinfo.php 274 2007-05-29 03:43:03Z hodaka $
 * Copyright (c) 2003 by Jeremy N. Cowgar <jc@cowgar.com>
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

//if( defined( 'FOR_XOOPS_LANG_CHECKER' ) ) $mydirname = 'weblog' ;
$constpref = '_MI_' . strtoupper( $mydirname ) ;

if( defined( 'FOR_XOOPS_LANG_CHECKER' ) || ! defined( $constpref.'_LOADED' ) ) {

define( $constpref.'_LOADED' , 1 ) ;

define($constpref.'_NAME','weBLog');
define($constpref.'_DESC','weBLogging/Journal system');
define($constpref.'_SMNAME1','My weBLog');
define($constpref.'_SMNAME2','Post');
define($constpref.'_SMNAME3','Archives');

// submenu name
define($constpref.'_ADMENU_IMPORTMANAGER', 'Database import');
define($constpref.'_DBMANAGER', 'Database');
define($constpref.'_CATMANAGER', 'Categories');
define($constpref.'_PRIVMANAGER', 'Privileges(weBLog simple)');
define($constpref.'_MYGROUPSADMIN', 'Privileges(XOOPS standard)');
define($constpref.'_MYBLOCKSADMIN', 'Blocks and Groups');
define($constpref.'_TEMPLATE_MANEGER', 'Templates');

define($constpref.'_NOTIFY','This weBLog');
define($constpref.'_NOTIFYDSC','When something happens to this weBLog');
define($constpref.'_ENTRY_NOTIFY','This weBLog entry');
define($constpref.'_ENTRY_NOTIFYDSC','When something happens to this weBLog entry');

define($constpref.'_ADD_NOTIFY','New Post');
define($constpref.'_ADD_NOTIFYCAP','Notify me when a new post occurs');
define($constpref.'_ADD_NOTIFYDSC','When a new post is made');
define($constpref.'_ADD_NOTIFYSBJ','New weBLog Post');

define($constpref.'_ENTRY_COMMENT','Comment Added');
define($constpref.'_ENTRY_COMMENTDSC','Notify me when a new comment is posted for this item.');

define($constpref.'_RECENT_BNAME1','Recent weBLogs');
define($constpref.'_RECENT_BNAME1_DESC','Recent weBLog Entries');
define($constpref.'_LATEST_CONTENT','Recent weBLogs(cron)');
define($constpref.'_LATEST_CONTENT_DESC','Recent weBLog Entries(cron)');
define($constpref.'_TOP_WEBLOGS','Top weBLogs');
define($constpref.'_TOP_WEBLOGS_DESC','Top weBLogs');
define($constpref.'_USERS_WEBLOGS','Users\' weBLogs');
define($constpref.'_USERS_WEBLOGS_DESC','Recent weBLogs group by user');
define($constpref.'_RECENT_TRACKBACKS','Recent Trackbacks');
define($constpref.'_RECENT_TRACKBACKS_DESC','Recent Recieved Trackbacks ');
define($constpref.'_RECENT_COMMENTS','Recent Comments');
define($constpref.'_RECENT_COMMENTS_DESC','Recent Comments to weBLog entries');
define($constpref.'_LINKS','weBLog owner\'s Links');
define($constpref.'_LINKS_DESC','Links integrated with a links module');
define($constpref.'_RECENT_IMAGES','Recent Images');
define($constpref.'_RECENT_IMAGES_DESC','Recent Images used by weBLog');
define($constpref.'_CATEGORY_LIST', 'Category list');
define($constpref.'_CATEGORY_LIST_DESC', 'Category list with counts');
define($constpref.'_TB_CENTER', 'Trackback Center');
define($constpref.'_TB_CENTERDSC', 'Show entries you want trackbacks especially');
// hodaka added archive list block
define($constpref.'_ARCHIVE_LIST', 'Archives list');
define($constpref.'_ARCHIVE_LIST_DESC', 'Archives list enables to sort by');
// hodaka added calendar block
define($constpref.'_CALENDAR', 'Weblog Calendar');
define($constpref.'_CALENDAR_DESC', 'Weblog monthly calendar');

// Config Settings
define($constpref.'_NUMPERPAGE','Number of entries per page');
define($constpref.'_NUMPERPAGEDSC','');
define($constpref.'_DATEFORMAT','Date format');
define($constpref.'_DATEFORMATDSC','');
define($constpref.'_TIMEFORMAT','Time format');
define($constpref.'_TIMEFORMATDSC','');
define($constpref.'_RECENT_DATEFORMAT','Date format in Recent weBLog\'s');
define($constpref.'_RECENT_DATEFORMATDSC','');
define($constpref.'_SHOWAVATAR','Show users avatar on each entry');
define($constpref.'_SHOWAVATARDSC','');
define($constpref.'_ALIGNAVATAR','Align avatar');
define($constpref.'_ALIGNAVATARDSC','');
define($constpref.'_MINENTRYSIZE','Minimum size of entry (0=size checking disabled)');
define($constpref.'_MINENTRYSIZEDSC','');
define($constpref.'_IMGURL', 'Image URL');
define($constpref.'_IMGURLDSC', 'URL of image that is shown or indicated in printer-friendly page and RSS');
define($constpref.'_OPDOHTML', 'Option/Disable HTML') ;
define($constpref.'_OPDOHTMLDSC', 'If you want to be checked disable HTML Option as default , set "Yes".') ;
define($constpref.'_OPDOBR', 'Option/Auto wrap lines') ;
define($constpref.'_OPDOBRDSC', 'If you want to be checked "Auto wrap lines" Option as default , set "Yes".') ;
define($constpref.'_OPPRIVATE', 'Option/Private') ;
define($constpref.'_OPPRIVATEDSC', 'If you want to be checked Private Option as default , set "Yes".') ;
define($constpref.'_OPUPDATEPING', 'Option/Update ping') ;
define($constpref.'_OPUPDATEPINGDSC', 'If you want to be checked Update ping Option as default , set "Yes".') ;
define($constpref.'_UPDATEPING_URL', 'Update Ping Server');
define($constpref.'_UPDATEPING_URL_DSC', 'break lines if plural');
define($constpref.'_UPDATEPING_SERVERS',"http://bulkfeeds.net/rpc\nhttp://ping.bloggers.jp/rpc/\nhttp://ping.myblog.jp/\nhttp://blog.goo.ne.jp/XMLRPC" );

define($constpref.'_UPDATE_READS_WHEN','Update read counter when');
define($constpref.'_UPDATE_READS_WHENDSC','');
define($constpref.'_UPDATE_READS_WHEN1','When viewing details');
define($constpref.'_UPDATE_READS_WHEN2','When viewing users weBLog');
define($constpref.'_UPDATE_READS_WHEN3','When viewing entry in any list');
define($constpref.'_GTICKETTIMEOUT','Time out setting when you post an entry.');
define($constpref.'_GTICKETTIMEOUTDSC','Entry must be posted for this time. (unit is minute)');

define($constpref.'_TEMPLATE_ENTRIESDSC','Display entries for the given weBLog');
define($constpref.'_TEMPLATE_POSTDSC','Post a new weBLog entry');
define($constpref.'_TEMPLATE_DETAILSDSC','Display details about a weBLog entry');
define($constpref.'_TEMPLATE_RSSFEEDDSC','RSS feed of weBLog entries');
define($constpref.'_TEMPLATE_PRINTDSC','Printer friendly page');
define($constpref.'_TEMPLATE_ARCHIVEDSC','Monthly archives');
define($constpref.'_TEMPLATE_IMAGEMANAGERDSC','weBLog Image Manager');
define($constpref.'_CALBLOCKCSS_DSC','CSS for calendar block');
// myarchive.php by hodaka
define($constpref.'_TEMPLATE_MYARCHIVEDSC', 'Sort archives');

define($constpref.'_EDITORHEIGHT','Height of editor box (lines)');
define($constpref.'_EDITORHEIGHTDSC','');
define($constpref.'_EDITORWIDTH','Width of editor box (characters)');
define($constpref.'_EDITORWIDTHDSC','');
define($constpref.'_ONLYADMIN',"Allow only module admin's to post?");
define($constpref.'_ONLYADMINDSC','Setting to no will allow all registered users to post, while yes would mean only module administrators can post.(This setting is valid when you choose "weBLog" as privilege system.)');
define($constpref.'_POST_COUNTUP',"Count up XOOPS USERS POSTS number");
define($constpref.'_POST_COUNTUPDSC','Setting count up users posts when user post Blog entry .');
define($constpref.'_DISABLE_HTML',"Forbidden HTML tags to all users");
define($constpref.'_DISABLE_HTMLDSC','From a viewpoint of Security, Please set this "YES" if you cannot trust all your registrants.');
define($constpref.'_TB_BLOGNAME',"Set strings when your user send trackbacks to another Blog, you use as BLOG TITLE.");
define($constpref.'_TB_BLOGNAMEDSC','You can use {MODULE_NAME},{USER_NAME},{SITE_NAME}');

// wellwine for read cookie
define($constpref.'_EXPIRATION','Expiration of read count (second)');
define($constpref.'_EXPIRATIONDSC','Define the time expiration of each blog read count. The count will be incremented if it has passed this period since last viewing.');
define($constpref.'_RSSSHOW','Show an icon linked to RSS feed');
define($constpref.'_RSSSHOWDSC','');
define($constpref.'_RSSMAX','The number of entries to be fed in RSS');
define($constpref.'_RSSMAXDSC','');

define($constpref.'_USESEPARATOR','use entry division function');
define($constpref.'_USESEPARATORDSC','inserting separator , you can divide entry as first half and latter half. First half is shown at index.php and Full entry is shown at details.php');
define($constpref.'_USESMEMBERONLY','use menber only readable function');
define($constpref.'_USESMEMBERONLYDSC','inserting separator , you can make part of entry which only registered member can read.');
define($constpref.'_USEIMAGEMANAGER','use weBLog Image manager');
define($constpref.'_USEIMAGEMANAGERDSC','You can use weBLog image manager different with XOOPS core image manager. It can deal thumbnail view.');
define($constpref.'_USEPERMITSYSTEM','add permission to each entry');
define($constpref.'_USEPERMITSYSTEMDSC','You can add permission attribute which groups can read or not');
define($constpref.'_DEFAULT_PERMIT','Default permission when using permission system');
define($constpref.'_DEFAULT_PERMITDSC','Default permission when user post new entry');
define($constpref.'_PERMIT_SHOWTITLE','Show only title when user is not allowed to read') ;
define($constpref.'_PERMIT_SHOWTITLEDSC','If you choose "No", user should not notice whether what kind of entry exists.<br/>Notice: if you choose "Yes",user can read trackbacks and comments of forbidden entries.') ;
//define($constpref.'_PERMIT_INGROUP' , 'Define what is "SAME GROUP"');
//define($constpref.'_PERMIT_INGROUPDSC' , '');
//define($constpref.'_PERMIT_OUTGROUP' , 'Define what is "DIFFERENT GROUP"');
//define($constpref.'_PERMIT_OUTGROUPDSC' , '');
//define($constpref.'_PERMIT_G_COMPLETE_S','All belong groups are completely the same');
//define($constpref.'_PERMIT_G_PARTIAL_S','At least one belong group is same');
//define($constpref.'_PERMIT_G_COMPLETE_D','No belong group is same');
//define($constpref.'_PERMIT_G_PARTIAL_D','At least one belong group is different');
define($constpref.'_PRIVILEGE_SYSTEM','Privilege System');
define($constpref.'_PRIVILEGE_SYSTEMDSC','You can choose "weBLog" or "XOOPS". "weBLog" is used till ver.1.41 as in the past and is simple. "XOOPS" is using XOOPS core privilege function and is detailed.');
define($constpref.'_SHOWCATEGORY','SHOW CATEGORY LIST OR NOT');
define($constpref.'_SHOWCATEGORY_DSC','SHOW CATEGORY LIST IN index.php');
define($constpref.'_CAT_POSTPERM','Category permission system when posting');
define($constpref.'_CAT_POSTPERM_DSC','Selecting "YES", you can controll posting category permission by every group.');
define($constpref.'_CAT_LISTCOL','NUMBER OF COLUMNS OF CATEGORY LIST');
define($constpref.'_CAT_LISTCOL_DSC','');

// myalbum-P imagemanager
// Config Items
define( "_MI_ALBM_CFG_PHOTOSPATH" , "Path to photos" ) ;
define( "_MI_ALBM_CFG_DESCPHOTOSPATH" , "Path from the directory installed XOOPS.<br />(The first character must be '/'. The last character should not be '/'.)<br />This directory's permission is 777 or 707 in unix." ) ;
define( "_MI_ALBM_CFG_THUMBSPATH" , "Path to thumbnails" ) ;
define( "_MI_ALBM_CFG_DESCTHUMBSPATH" , "Same as 'Path to photos'." ) ;
//define( "_MI_ALBM_CFG_THUMBWIDTH" , "Thumb Image Width" ) ;
//define( "_MI_ALBM_CFG_DESCTHUMBWIDTH" , "The height of thumbs will be decided from the width automatically." ) ;
define( "_MI_ALBM_CFG_THUMBSIZE" , "Size of thumbnails (pixel)" ) ;
define( "_MI_ALBM_CFG_THUMBRULE" , "Calc rule for building thumbnails" ) ;
define( "_MI_ALBM_CFG_WIDTH" , "Max photo width" ) ;
define( "_MI_ALBM_CFG_DESCWIDTH" , "This means the photo's width to be resized.<br />If you use GD without truecolor, this means the limitation of width." ) ;
define( "_MI_ALBM_CFG_HEIGHT" , "Max photo height" ) ;
define( "_MI_ALBM_CFG_DESCHEIGHT" , "Same as 'Max photo width'." ) ;
define( "_MI_ALBM_CFG_FSIZE" , "Max file size" ) ;
define( "_MI_ALBM_CFG_DESCFSIZE" , "The limitation of the size of uploading file.(byte)" ) ;
define( "_MI_ALBM_CFG_MIDDLEPIXEL" , "Max image size in single view" ) ;
//define( "_MI_ALBM_CFG_DESCMIDDLEPIXEL" , "Specify (width)x(height)<br />eg) 480x480" ) ;

define( "_MI_ALBUM_OPT_CALCFROMWIDTH" , "width:specified  height:auto" ) ;
define( "_MI_ALBUM_OPT_CALCFROMHEIGHT" , "width:auto  width:specified" ) ;
define( "_MI_ALBUM_OPT_CALCWHINSIDEBOX" , "put in specified size squre" ) ;

// hodaka added against for trackback spams
define($constpref.'_USE_TBTICKET','Trackback url with a temporary ticket');
define($constpref.'_USE_TBTICKET_DESC','Need to get a key every time. lifetime is 24h by default.');
define($constpref.'_CHECK_LANGUAGE','Reject trackbacks with no Japanese words in a blog name or a blog title<br />(Select required number of letters,Hiragana,Katakana or Kanji)');
define($constpref.'_CHECK_LANGUAGE_DESC','No need in no multi-bytes countries');
define($constpref.'_NO_CHECK_LANGUAGE','No need to check');
define($constpref.'_LANGUAGE_NEEDLETTER1','1 letter or more');
define($constpref.'_LANGUAGE_NEEDLETTER2','2 letters or more');
define($constpref.'_LANGUAGE_NEEDLETTER3','3 letters or more');

define($constpref.'_SPAM_WORDS','Banned words in trackbacks');
define($constpref.'_SPAM_WORDS_DESC','Each word must be seperated by "|"');

define($constpref.'_CHECK_RBL','Check RBL');
define($constpref.'_CHECK_RBL_DESC','');
define($constpref.'_RBL_LIST','url of RBL<br />Each must be seperated by "|"');
define($constpref.'_RBL_LIST_DESC','');
define($constpref.'_SEND_TO_ADMIN','Send spam notification mail to the administrator');
define($constpref.'_SEND_TO_ADMIN_DESC','');
define($constpref.'_TRACKBACK_NOTIFY','Send trackback notification mail to the administrator');
define($constpref.'_TRACKBACK_NOTIFY_DESC','');
define($constpref.'_SEND_ADDRESS','Each mail address must be seperated by "|"<br />Send to admin if none');
define($constpref.'_SEND_ADDRESS_DESC','');
}
?>