<?php
/**
 * $Id: modinfo.php 223 2007-11-16 12:10:36Z hodaka $
 * Copyright (c) 2003 by Jeremy N. Cowgar <jc@cowgar.com>
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
/*
 * version j0.90 2003/05/18 JST
 * Traslated into Japanese by wellwine (http://wellwine.zive.net)
 * Copyright (c) 2003 by wellwine
 *
 * version j0.91 2003/05/19 JST
 */

$constpref = '_MI_' . strtoupper( $mydirname ) ;

if( defined( 'FOR_XOOPS_LANG_CHECKER' ) || ! defined( $constpref.'_LOADED' ) ) {

define( $constpref.'_LOADED' , 1 ) ;

// The name of this module
define($constpref.'_NAME','うぇブログＤ３');
// A brief description of this module
define($constpref.'_DESC','ブログ/ジャーナルシステム');

define($constpref.'_SMNAME1','マイブログ');
define($constpref.'_SMNAME2','ブログ投稿');
define($constpref.'_SMNAME3','アーカイブ');

// admin menu
define($constpref.'_ADMENU_IMPORTMANAGER', 'インポートマネジャー');
define($constpref.'_ADMENU_CATMANAGER', 'カテゴリ管理');
define($constpref.'_ADMENU_PRIVMANAGER', '権限管理(weBLog simple)');
define($constpref.'_ADMENU_MYGROUPSADMIN', '権限管理(XOOPS standard)');
//define($constpref.'_MYBLOCKSADMIN', 'ブロック・アクセス権限');
//define($constpref.'_TEMPLATE_MANEGER', 'テンプレート・マネージャ');

define($constpref.'_NOTIFY_GLOBAL','ブログ全体');
define($constpref.'_NOTIFY_GLOBAL_DSC','このブログに投稿があった場合に通知する');
define($constpref.'_NOTIFY_BLOGGER','このブロガー');
define($constpref.'_NOTIFY_BLOGGER_DSC','このブロガーのブログ投稿があった場合に通知する');
define($constpref.'_NOTIFY_CATEGORY','このカテゴリー');
define($constpref.'_NOTIFY_CATEGORY_DSC','このカテゴリーに投稿があった場合に通知する');
define($constpref.'_NOTIFY_ENTRY','表示中のブログエントリ');
define($constpref.'_NOTIFY_ENTRY_DSC','表示中のブログエントリに変更があった場合に通知する');

/*define($constpref.'_NOTIFY','表示中のブログ');
define($constpref.'_NOTIFYDSC','このブログに変更があった場合に通知する');
define($constpref.'_ENTRY_NOTIFY','表示中のブログエントリ');
define($constpref.'_ENTRY_NOTIFYDSC','このブログエントリに変更があった場合に通知する');*/

define($constpref.'_NOTIFY_SENT_GLOBAL','新規投稿');
define($constpref.'_NOTIFY_SENT_GLOBAL_CAP','このブログに新しいエントリが投稿された場合に通知する');
define($constpref.'_NOTIFY_SENT_GLOBAL_DSC','このブログに新しいエントリが投稿されたとき');
define($constpref.'_NOTIFY_SENT_GLOBAL_SBJ','新規ブログ投稿');
define($constpref.'_NOTIFY_SENT_BLOGGER','このブロガーの新規投稿');
define($constpref.'_NOTIFY_SENT_BLOGGER_CAP','このブロガーの新しいエントリが投稿された場合に通知する');
define($constpref.'_NOTIFY_SENT_BLOGGER_DSC','このブロガーの新しいエントリが投稿されたとき');
define($constpref.'_NOTIFY_SENT_BLOGGER_SBJ','このブロガーの新規ブログ投稿');
define($constpref.'_NOTIFY_SENT_CATEGORY','カテゴリーの新規投稿');
define($constpref.'_NOTIFY_SENT_CATEGORY_CAP','このカテゴリーに新しいエントリが投稿された場合に通知する');
define($constpref.'_NOTIFY_SENT_CATEGORY_DSC','このカテゴリーに新しいエントリが投稿されたとき');
define($constpref.'_NOTIFY_SENT_CATEGORY_SBJ','カテゴリーに新規ブログ投稿');
define($constpref.'_NOTIFY_SENT_ENTRY','新規投稿');
define($constpref.'_NOTIFY_SENT_ENTRY_CAP','新しいエントリが投稿された場合に通知する');
define($constpref.'_NOTIFY_SENT_ENTRY_DSC','新しいエントリが投稿されたとき');
define($constpref.'_NOTIFY_SENT_ENTRY_SBJ','新規ブログ投稿');

/*define($constpref.'_ADD_NOTIFY','新規投稿');
define($constpref.'_ADD_NOTIFYCAP','新しいエントリが投稿された場合に通知する');
define($constpref.'_ADD_NOTIFYDSC','新しいエントリが投稿されたとき');
define($constpref.'_ADD_NOTIFYSBJ','新規ブログ投稿');*/

define($constpref.'_ENTRY_COMMENT','追加されたコメント');
define($constpref.'_ENTRY_COMMENTDSC','このエントリに新しいコメントが投稿された場合に通知する');

define($constpref.'_RECENT_BNAME1','最新ブログエントリ');
define($constpref.'_RECENT_BNAME1_DESC','最新ブログエントリ');
define($constpref.'_LATEST_CONTENT','最新ブログエントリ（コピー）');
define($constpref.'_LATEST_CONTENT_DESC','最新ブログエントリ（コピー）');
define($constpref.'_TOP_WEBLOGS','トップブログエントリ');
define($constpref.'_TOP_WEBLOGS_DESC','もっとも読まれているブログエントリ');
define($constpref.'_USERS_WEBLOGS','投稿者別エントリ');
define($constpref.'_USERS_WEBLOGS_DESC','ユーザー毎の最新ブログエントリ');
define($constpref.'_RECENT_TRACKBACKS','最近のトラックバック');
define($constpref.'_RECENT_TRACKBACKS_DESC','最近受信したトラックバック一覧');
define($constpref.'_RECENT_COMMENTS','最近のブログのコメント');
define($constpref.'_RECENT_COMMENTS_DESC','ブログのエントリに最近付けられたコメント');
define($constpref.'_LINKS','weBLog投稿者用リンク');
define($constpref.'_LINKS_DESC','リンクモジュール統合のリンクリスト');
define($constpref.'_RECENT_IMAGES','最近のイメージ');
define($constpref.'_RECENT_IMAGES_DESC','weBLogで最近使われたイメージ');
define($constpref.'_CATEGORY_LIST', 'カテゴリ一覧');
define($constpref.'_CATEGORY_LIST_DESC', '件数つきカテゴリ一覧');
define($constpref.'_TB_CENTER', 'トラックバックセンター');
define($constpref.'_TB_CENTERDSC', 'トラックバックを特に集めたいエントリの一覧');
// hodaka added archive list block
define($constpref.'_ARCHIVE_LIST', 'アーカイブ');
define($constpref.'_ARCHIVE_LIST_DESC', '並べ替え可能なアーカイブ');
// hodaka added calendar block
define($constpref.'_CALENDAR', 'ブログ カレンダー');
define($constpref.'_CALENDAR_DESC', '１ヶ月カレンダー');
// hodaka added latest contents block
define($constpref.'_LATEST_BLOG_CONTENTS','最新ブログコンテンツ');
define($constpref.'_LATEST_BLOG_CONTENTS_DESC','最新ブログコンテンツ');

// Config setting
define($constpref.'_NUMPERPAGE','１ページ毎に表示するエントリ数');
define($constpref.'_NUMPERPAGEDSC','');
define($constpref.'_DATEFORMAT','日付書式');
define($constpref.'_DATEFORMATDSC','');
define($constpref.'_TIMEFORMAT','時刻書式');
define($constpref.'_TIMEFORMATDSC','');
define($constpref.'_RECENT_DATEFORMAT','最新エントリブロック日付書式');
define($constpref.'_RECENT_DATEFORMATDSC','');
define($constpref.'_SHOWAVATAR','各エントリにアバターを表示する');
define($constpref.'_SHOWAVATARDSC','');
define($constpref.'_ALIGNAVATAR','アバターの整列');
define($constpref.'_ALIGNAVATARDSC','');
define($constpref.'_MINENTRYSIZE','エントリの最低サイズ');
define($constpref.'_MINENTRYSIZEDSC','0を指定するとサイズをチェックしません');
define($constpref.'_IMGURL', '画像URL');
define($constpref.'_IMGURLDSC', '印刷用ページおよびRSSに表示または記述される画像のURLを設定します。');
define($constpref.'_OPDOHTML', 'オプション/HTMLタグを無効') ;
define($constpref.'_OPDOHTMLDSC', '「HTMLタグを無効」のオプションをデフォルトでチェックの状態にする場合は"はい"に') ;
define($constpref.'_OPDOBR', 'オプション/改行を自動挿入する') ;
define($constpref.'_OPDOBRDSC', '「改行を自動挿入する」のオプションをデフォルトでチェックの状態にする場合は"はい"に') ;
define($constpref.'_OPPRIVATE', 'オプション/プライベート') ;
define($constpref.'_OPPRIVATEDSC', '「プライベート」のオプションをデフォルトでチェックの状態にする場合は"はい"に') ;
define($constpref.'_OPUPDATEPING', 'オプション/更新Pingを送る') ;
define($constpref.'_OPUPDATEPINGDSC', '「更新Pingを送る」のオプションをデフォルトでチェックの状態にする場合は"はい"に') ;
define($constpref.'_UPDATEPING_URL', '更新pingサーバーのurl');
define($constpref.'_UPDATEPING_URL_DSC', '複数ある場合は、各サーバーごとに改行してください');
define($constpref.'_UPDATEPING_SERVERS',"http://bulkfeeds.net/rpc\nhttp://ping.bloggers.jp/rpc/\nhttp://ping.myblog.jp/\nhttp://blog.goo.ne.jp/XMLRPC" );

define($constpref.'_UPDATE_READS_WHEN','閲覧数をカウントアップするのは');
define($constpref.'_UPDATE_READS_WHENDSC','「詳細が閲覧されたとき」では詳細画面でエントリを閲覧したとき、「ユーザのリストが閲覧されたとき」ではあるユーザだけのエントリをリストアップしたとき、「リストが閲覧されたとき」ではどんな形であれエントリがリストアップされたとき、それぞれ閲覧数が更新されます。');
define($constpref.'_UPDATE_READS_WHEN1','詳細が閲覧されたとき');
define($constpref.'_UPDATE_READS_WHEN2','ユーザのリストが閲覧されたとき');
define($constpref.'_UPDATE_READS_WHEN3','リストが閲覧されたとき');
define($constpref.'_GTICKETTIMEOUT','投稿する時の制限時間');
define($constpref.'_GTICKETTIMEOUTDSC','投稿ページを開いてから、この分数以内に投稿しないとタイムアウト処理されます。');

define($constpref.'_TEMPLATE_ENTRIESDSC','指定されたブログのエントリを表示する');
define($constpref.'_TEMPLATE_POSTDSC','新しいブログエントリを投稿する');
define($constpref.'_TEMPLATE_DETAILSDSC','ブログエントリの詳細を表示する');
define($constpref.'_TEMPLATE_RSSFEEDDSC','最新エントリのRSSフィード');
define($constpref.'_TEMPLATE_PRINTDSC','印刷用ページ');
define($constpref.'_TEMPLATE_ARCHIVEDSC','月ごとのアーカイブリスト');
define($constpref.'_TEMPLATE_IMAGEMANAGERDSC','ブログ用のイメージマネージャ');
define($constpref.'_CALBLOCKCSS_DSC','カレンダーブロック用のスタイルシート');
// myarchive.php by hodaka
define($constpref.'_TEMPLATE_MYARCHIVEDSC', '並べ替え用アーカイブリスト');

define($constpref.'_EDITORHEIGHT','編集用テキストエリアの高さ(行)');
define($constpref.'_EDITORHEIGHTDSC','編集用テキストエリアの高さを行数で設定します。');
define($constpref.'_EDITORWIDTH','編集用テキストエリアの幅(文字)');
define($constpref.'_EDITORWIDTHDSC','編集用テキストエリアの幅を字数で設定します。');
define($constpref.'_ONLYADMIN','管理人グループユーザのみが投稿できる');
define($constpref.'_ONLYADMINDSC','「いいえ」を設定するとすべての登録ユーザがエントリを投稿することができます。つまり「はい」を設定すると管理人グループのユーザだけが投稿できます。(この設定は権限管理方法に"weBLog"を選んだときに有効です)');
define($constpref.'_POST_COUNTUP','投稿をユーザーの投稿数に反映');
define($constpref.'_POST_COUNTUPDSC','エントリを投稿した時にXOOPSユーザーの投稿数としてカウントするかどうかの設定です');
define($constpref.'_DISABLE_HTML','HTMLタグを強制的に使用不可にします');
define($constpref.'_DISABLE_HTMLDSC','信頼できないユーザーが登録でき、エントリを投稿できる場合、セキュリティ上「はい」にしてください');
define($constpref.'_TB_BLOGNAME','トラックバック送信時に「ブログ名」として使う文字列');
define($constpref.'_TB_BLOGNAMEDSC','{MODULE_NAME}をモジュール名、{USER_NAME}をユーザー名、{SITE_NAME}をサイト名として使えます');

// wellwine for read cookie
define($constpref.'_EXPIRATION','閲覧済みの有効期限(単位:秒)');
define($constpref.'_EXPIRATIONDSC','ブログエントリごとの閲覧済み有効期限を設定してください。この期間を過ぎて同じエントリを閲覧すると閲覧数が更新されます。');
define($constpref.'_RSSSHOW','RSSアイコンを表示する');
define($constpref.'_RSSSHOWDSC','');
define($constpref.'_RSSMAX','RSSにフィードされるエントリ数');
define($constpref.'_RSSMAXDSC','');

define($constpref.'_USESEPARATOR','エントリの前後半分け機能の使用');
define($constpref.'_USESEPARATORDSC','区切り文字を入れることで、エントリを前半と後半に分けることができます。一覧には前半部分のみが表示され、詳細ページにはエントリの全部が表示されます。');
define($constpref.'_USESMEMBERONLY','登録ユーザのみ閲覧可能部分の使用');
define($constpref.'_USESMEMBERONLYDSC','区切り文字を入れることで、エントリのそれ以降の部分は登録ユーザのみが読めるようになります。');
define($constpref.'_USEIMAGEMANAGER','うぇブログ用イメージマネージャの使用');
define($constpref.'_USEIMAGEMANAGERDSC','標準のイメージマネージャとは別に、サムネイル表示など投稿時に画像が扱えます。');
define($constpref.'_USEPERMITSYSTEM','各エントリごとのパーミション設定機能の使用');
define($constpref.'_USEPERMITSYSTEMDSC','この機能は、エントリの投稿時にどのグループに閲覧権限を与えるかの設定ができます');
define($constpref.'_DEFAULT_PERMIT','パーミッションを有効にしている時のデフォルト値');
define($constpref.'_DEFAULT_PERMITDSC','投稿時にデフォルトで選ばれているパーミションです。');
define($constpref.'_PERMIT_SHOWTITLE','閲覧権限がないユーザにもタイトルだけは表示する') ;
define($constpref.'_PERMIT_SHOWTITLEDSC','タイトルのみ表示させることで、どんなエントリがあるか気づかせることができます。ただし、この機能をONにした場合、ユーザは禁止されているエントリのトラックバックとコメントは読むことができるようになります。') ;

define($constpref.'_PRIVILEGE_SYSTEM','ブログモジュールの権限管理方法');
define($constpref.'_PRIVILEGE_SYSTEMDSC','バージョン1.41までのうぇブログ独自のシンプルな権限管理方法と、XOOPS標準の権限管理方法のどちらを使うかを選べます');
define($constpref.'_SHOWCATEGORY','カテゴリ一覧の表示');
define($constpref.'_SHOWCATEGORY_DSC','index.phpでカテゴリ一覧を見せる場合は、"はい"にしてください。');
define($constpref.'_CAT_POSTPERM','投稿時のカテゴリ選択の制限機能');
define($constpref.'_CAT_POSTPERM_DSC','有効にした場合、ユーザが投稿できるカテゴリをグループ毎に設定できます。');
define($constpref.'_CAT_LISTCOL','カテゴリ一覧の段数');
define($constpref.'_CAT_LISTCOL_DSC','カテゴリ一覧を表示する場合、1列に何個表示するか');

// myalbum-P image manager
// Config Items
define( $constpref.'_CFG_PHOTOSPATH' , '画像ファイルの保存先ディレクトリ' ) ;
define( $constpref.'_CFG_DESCPHOTOSPATH' , 'XOOPSインストール先からのパスを指定（最初の\'/\'は必要、最後の\'/\'は不要）<br />Unixではこのディレクトリへの書込属性をONにして下さい' ) ;
define( $constpref.'_CFG_THUMBSPATH' , 'サムネイルファイルの保存先ディレクトリ' ) ;
define( $constpref.'_CFG_DESCTHUMBSPATH' , '「画像ファイルの保存先ディレクトリ」と同じです' ) ;
//define( $constpref.'_CFG_THUMBWIDTH' , 'サムネイル画像の幅' ) ;
//define( $constpref.'_CFG_DESCTHUMBWIDTH' , '生成されるサムネイル画像の高さは、幅から自動計算されます' ) ;
define( $constpref.'_CFG_THUMBSIZE' , 'サムネイル画像サイズ(pixel)' ) ;
define( $constpref.'_CFG_THUMBRULE' , 'サムネイル生成法則' ) ;
define( $constpref.'_CFG_WIDTH' , '最大画像幅' ) ;
define( $constpref.'_CFG_DESCWIDTH' , '画像アップロード時に自動調整されるメイン画像の最大幅。<br />GDモードでTrueColorを扱えない時には単なるサイズ制限' ) ;
define( $constpref.'_CFG_HEIGHT' , '最大画像高' ) ;
define( $constpref.'_CFG_DESCHEIGHT' , '最大幅と同じ意味です' ) ;
define( $constpref.'_CFG_FSIZE' , '最大ファイルサイズ' ) ;
define( $constpref.'_CFG_DESCFSIZE' , 'アップロード時のファイルサイズ制限(byte)' ) ;
define( $constpref.'_CFG_MIDDLEPIXEL' , 'シングルビューでの最大画像サイズ' ) ;
//define( $constpref.'_CFG_DESCMIDDLEPIXEL' , '幅x高さ で指定します。<br />（例 480x480）' ) ;

define( $constpref.'_OPT_CALCFROMWIDTH' , '指定数値を幅として、高さを自動計算' ) ;
define( $constpref.'_OPT_CALCFROMHEIGHT' , '指定数値を高さとして、幅を自動計算' ) ;
define( $constpref.'_OPT_CALCWHINSIDEBOX' , '幅か高さの大きい方が指定数値になるよう自動計算' ) ;
// hodaka added for trackback spam
define($constpref.'_USE_TBTICKET','チケット式トラックバックURLを使う');
define($constpref.'_USE_TBTICKET_DESC','都度入手する必要があります。生存時間はデフォルトで1日。');

define($constpref.'_CHECK_LANGUAGE','trackbackのタイトルとブログ名の日本語チェック<br />(ひらがな、カタカナ、漢字含めた必要文字数を選択する)');
define($constpref.'_CHECK_LANGUAGE_DESC','日本語を必須とする場合に有効になります。すべてが必要字数を下回る場合SPAMとみなします。');
define($constpref.'_NO_CHECK_LANGUAGE','チェックしない');
define($constpref.'_LANGUAGE_NEEDLETTER1','1文字以上');
define($constpref.'_LANGUAGE_NEEDLETTER2','2文字以上');
define($constpref.'_LANGUAGE_NEEDLETTER3','3文字以上');

define($constpref.'_SPAM_WORDS','trackback撃退ワード');
define($constpref.'_SPAM_WORDS_DESC','各語の区切りは|です');

define($constpref.'_CHECK_RBL','RBLチェックを行う');
define($constpref.'_CHECK_RBL_DESC','');
define($constpref.'_RBL_LIST','RBLのurl<br />各語の区切りは|です');
define($constpref.'_RBL_LIST_DESC','');
define($constpref.'_SEND_TO_ADMIN','spamが来たらメール通知する');
define($constpref.'_SEND_TO_ADMIN_DESC','');
define($constpref.'_TRACKBACK_NOTIFY','trackbackがあったらメール通知する');
define($constpref.'_TRACKBACK_NOTIFY_DESC','');
define($constpref.'_SEND_ADDRESS','通知先メールアドレス(複数ある場合は|で区切る)<br />特に指定しない場合は管理者宛');
define($constpref.'_SEND_ADDRESS_DESC','');
}
?>
